
/*\// -------------------------------------------------------------- */
/*\// Licensed Material - Property of IBM                            */
/*\//                                                                */
/*\// 5655-002                                                       */
/*\//                                                                */
/*\// (C) Copyright IBM Corp. 2003   All Rights Reserved             */
/*\//                                                                */
/*\// US Government Users Restricted Rights - Use, duplication or    */
/*\// disclosure restricted by GSA ASP Schedule Contract with        */
/*\// IBM Corp.                                                      */
/*\// -------------------------------------------------------------- */
var g_CurRadioButton = null;
function fnInit()
{
var vCurRadioButtonCnt;
var vSelRadioButtonCnt;
var vRadioButtonObj;
g_whatAmI = "term";
setLanguage(g_languageid);
fnInitCommon();
fnSetFocus2MainPanel();
if (g_continueRequestCode > 0)
{
switch (g_continueRequestCode)
{
case '34':
fnButtonPrintPreview("termquickpreview");
break;
case '35':
fnButtonPrintPreview("termpreview");
break;
default:
break;
}
}
tb0.focus();
fnCheckPendingMsg();
g_CurRadioButton   = "";
vCurRadioButtonCnt = 1;
vSelRadioButtonCnt = 1;
vRadioButtonObj    = document.getElementById("trb-" + vCurRadioButtonCnt + "");
while (vRadioButtonObj != null)
{
fnTermRBClicked(vRadioButtonObj.id);
if (vRadioButtonObj.isSelected == "Y")
{
vSelRadioButtonCnt = vCurRadioButtonCnt;
}
vCurRadioButtonCnt ++;
vRadioButtonObj = document.getElementById("trb-" + vCurRadioButtonCnt + "");
}
vRadioButtonObj         = document.getElementById("trb-" + vSelRadioButtonCnt + "");
if ( vRadioButtonObj != null )
{
vRadioButtonObj.checked = true;
fnTermRBClicked(vRadioButtonObj.id);
}
setTimeout("tb0.doScroll('scrollbarPageLeft');",g_paramScreenTimeout);
}
function fnBackgroundInit()
{
fnSetEventHandler("document.onselectstart", "fnOnSelectStartHandler");
fnSetEventHandler("document.onkeydown", "fnKeyEventHandler");
}
function fnCheckEmailAddress()
{
var    vInputElement    = window.event.srcElement;
var    vInput           = vInputElement.value;
var    vIsEmailAddress  = false;
var    vTrimmedInput    ;
vTrimmedInput = fnTrimString(vInput);
if ( vTrimmedInput.length != 0 )
{
vIsEmailAddress = fnIsEmailAddress(vInput);
}
if ( vIsEmailAddress == false )
{
vInputElement.style.color = "Red";
}
else
{
vInputElement.style.color = "Black";
}
return (vIsEmailAddress);
}
function fnIsEmailAddress(aString)
{
var vString;
var vRegExpString = /^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/;
var vIsEmailAddress = true;
vString = fnTrimString(aString);
vRegExp = new RegExp(vRegExpString);
if( vRegExp.test(aString) == false )
{
vIsEmailAddress = false;
}
return (vIsEmailAddress);
}
function fnCheckEmailAddressList(aEmptyAllowed)
{
var    vInputElement       = window.event.srcElement;
var    vInput              = vInputElement.value;
var    vIsEmailAddressList = false;
var    vTrimmedInput    ;
vTrimmedInput = fnTrimString(vInput);
if ( vTrimmedInput.length != 0 )
{
vIsEmailAddressList = fnIsEmailAddressList(vInput);
if ( vIsEmailAddressList == false )
{
vInputElement.style.color = "Red";
}
else
{
vInputElement.style.color = "Black";
}
}
else
{
if ( aEmptyAllowed == true )
{
vIsEmailAddressList = true;
}
}
return (vIsEmailAddressList);
}
function fnIsEmailAddressList(aString)
{
var vIsEmailAddressList = true;
var vIsEmailAddress     = true;
var vDelimiter = ",";
var i;
var vString;
var vArray = new Array();
var vArrayDimension ;
var vIndex = 0;
var vIsEmailAddressList = true;
var vIsNotEmailAddressFound = false;
var vTrimmedEmailAddress = null;
vString = aString.replace(/\s/g,'');
vArray = vString.split(vDelimiter);
vArrayDimension = vArray.length;
vIndex = 0;
while ( ( vIndex  < vArrayDimension ) && ( vIsNotEmailAddressFound == false ) )
{
vTrimmedEmailAddress =  fnTrimString( vArray[vIndex].replace(/\s/g,''));
vIsEmailAddress      =  fnIsEmailAddress(vTrimmedEmailAddress);
if ( vIsEmailAddress == false )
{
vIsNotEmailAddressFound = true;
}
vIndex++;
}
if ( vIsNotEmailAddressFound == true )
{
vIsEmailAddressList = false;
}
return (vIsEmailAddressList);
}
function fnGetKeyEventDefault(aCurrentIdPrefix)
{
var vRetBool = true;
var vKeySelection;
var lCurObjectId = fnGetGlobalVariable("gCurObjectId");
vKeySelection = getNLSKeyCode(event, g_languageid);
if (vKeySelection == null)
{
vKeySelection = event.keyCode + "";
}
switch (vKeySelection)
{
case "8":
if (aCurrentIdPrefix.substring(0,3) == "tif")
{
vRetBool = true;
}
else
{
fnIgnoreEvent();
}
break;
case "9":
vRetBool = fnWhereToGoTerm(aCurrentIdPrefix, event.shiftKey);
break;
case "27":
if (g_contextmenu)
{
ContextMenuMainClose();
fnSetFocus2Object(lCurObjectId);
}
else
{
fnButtonCancel();
fnIgnoreEvent();
}
break;
case "57":
if (event.altKey)
{
fnShowHTMLSource();
}
break;
case "50":
if (event.ctrlKey)
{
fnSnoop("0", g_whatAmI);
}
break;
case "112":
fnIgnoreEvent();
if (lCurObjectId == "tb1")
fnButtonShowHelp();
else if (lCurObjectId == "tb2")
fnShowHelp("tb2");
else
fnShowHelp("bTermFinished");
break;
case "116":
	          event.keyCode = 0;
	          event.returnValue = false;
	          event.cancelBubble = true;
	
	          break;
case "exitButton1":
fnButtonExit1();
break;
case "exitButton2":
fnButtonExit2();
break;
case "backToPrompting":
fnDeSelectButton(g_buttonselect);
fnButtonDPPrompting();
fnIgnoreEvent();
break;
case "buildblkselection":
fnDeSelectButton(g_buttonselect);
fnButtonPSelection();
fnIgnoreEvent();
break;
case "generalHelp":
fnIgnoreEvent();
fnShowHelp("x");
break;
case "custHelp":
fnIgnoreEvent();
fnShowCustHelp("term");
break;
case "helpMenu":
ContextMenuMain('hpmain','helpMenu')
break;
case "termFinished":
case "panelFinished":
fnDeSelectButton(g_buttonselect);
fnButtonTermFinished(false);
fnIgnoreEvent();
break;
case "processAndLeave":
fnDeSelectButton(g_buttonselect);
fnButtonTermFinished(true);
fnIgnoreEvent();
break;
case "previewButton":
fnDeSelectButton(g_buttonselect);
fnButtonPrintPreview("termquickpreview");
break;
case "printPreviewButton":
fnDeSelectButton(g_buttonselect);
fnButtonPrintPreview("termpreview");
break;
case "saveButton":
fnDeSelectButton(g_buttonselect);
fnButtonSave("termsave");
fnIgnoreEvent();
break;
case "49":
if (event.ctrlKey)
{
fnTraceChange();
}
break;
default:
if ((event.altKey || event.ctrlKey) && !(event.altKey && event.ctrlKey))
{
fnIgnoreEvent();
}
vRetBool = true;
break;
}
return (vRetBool);
}
function fnKeyEventHandler()
{
var vIdPrefix;
var vEventHandled = false;
if (gTopObj.applet.gEventsEnabled)
{
vIdPrefix = window.event.srcElement.id.substring(0, 3);
if ( vIdPrefix == "bod" )
{
vIdPrefix = "tdM";
}
switch (vIdPrefix)
{
case "tb1":
vEventHandled = fnGetKeyEvent();
break;
case "tb2":
case "nt-":
vEventHandled = fnGetKeyEventNAV();
break;
case "tdM":
vEventHandled = fnGetKeyEventMenu();
break;
default:
vEventHandled = false;
break;
}
if (vEventHandled == false)
{
if (fnGetKeyEventDefault(window.event.srcElement.id) == false)
{
fnIgnoreEvent();
}
}
}
else
{
fnProcessEnableWindowByUserRequest(g_whatAmI);
fnIgnoreEvent();
}
}
function fnOnSelectStartHandler()
{
var vIdPrefix;
var vCurObj;
if (gTopObj.applet.gEventsEnabled)
{
vIdPrefix = window.event.srcElement.id.substring(0, 3);
switch (vIdPrefix)
{
case "tif":
vCurObj = document.getElementById(window.event.srcElement.id);
while (vCurObj.tagName != "SPAN")
{
vCurObj = vCurObj.parentElement;
}
if (vCurObj.disabled)
{
fnIgnoreEvent();
}
break;
default:
fnIgnoreEvent();
break;
}
}
else
{
fnIgnoreEvent();
}
}
function fnOpenContextMenu()
{
fnSetFocus2MainPanel();
ContextMenuMain('cmmain','contextMenu');
g_contextmenu = true;
}
function fnGetKeyEventNAV()
{
var vEventHandled = true;
switch(event.keyCode)
{
case 13:
var v_hmenuselect = g_hmenuselect;
if (g_operation == "Saved")
{
if ((g_hmenulimit-0) > g_hmenuselect )
{
var vRespDB;
vRespDB = processYesCancelDialog(g_leavAppSavedNlsObj);
if (vRespDB)
{
fnNavigateonKeyDown(v_hmenuselect);
}
}
}
else
{
if ((g_hmenulimit-0) <= g_hmenuselect )
{
fnNavigateonKeyDown(v_hmenuselect);
}
else
{
var vRespDB;
vRespDB = processYesCancelDialog(g_leavAppUnsavedNlsObj);
if (vRespDB)
{
fnNavigateonKeyDown(v_hmenuselect);
}
}
}
break;
case 38:
fnCursorUpNavigation();
break;
case 40:
fnCursorDownNavigation();
break;
default:
vEventHandled = false;
break;
}
return(vEventHandled);
}
function fnSelectMenu()
{
var vDoNavigate = true;
if (gTopObj.applet.gObjId != null)
{
var vCurMenuObj;
var vCurMenuNbr;
vCurMenuNbr = gTopObj.applet.gObjId.substring(PREF_LEN+1);	
vCurMenuObj = document.getElementById("ns-" + vCurMenuNbr);
if (vCurMenuObj != null)
{
if (vCurMenuObj.className == "navigationspangrey")
{
vDoNavigate = false;
}
}
else
{
vDoNavigate = false;
}
}
if (vDoNavigate)
{
if (g_operation == "Saved")
{
if ((g_hmenulimit-0) > (event.srcElement.id.substring(3)-0) )
{
var vRespDB;
vRespDB = processYesCancelDialog(g_leavAppSavedNlsObj);
if (vRespDB)
{
fnNavigate();
}
}
else
{
fnNavigate();
}
}
else
{
if ((g_hmenulimit-0) <= (event.srcElement.id.substring(3)-0) )
{
fnNavigate();
}
else
{
var vRespDB;
vRespDB = processYesCancelDialog(g_leavAppUnsavedNlsObj);
if (vRespDB)
{
fnNavigate();
}
}
}
}
}
function fnTermRBClicked(aNewRadioButton)
{
var vRButtonObj;
var vInputFldObj;
var vSpanId;
var vSpanObj;
var vSelectListObj;
var vOptionArr;
if (aNewRadioButton != g_CurRadioButton)
{
vSpanId  = "fld-" + aNewRadioButton.substring(4);
vSpanObj = document.getElementById(vSpanId);
vSpanObj.disabled = false;
vRButtonObj = document.getElementById(aNewRadioButton);
switch(vRButtonObj.subid)
{
case "ImmediatePrint":
fnDisableChilds("select", vSpanObj, false);
vInputFldObj = document.getElementById("tif-CopyCnt");
if (vInputFldObj != null)
{
vInputFldObj.disabled = false;
}
fnSetFocus2FirstField(vSpanObj, "select");
vSelectListObj = document.getElementById("tif-select");
if (vSelectListObj != null)
{
vOptionArr = vSelectListObj.all.tags("option");
if (vOptionArr.length == 1)
{
if(vOptionArr[0].value != "read-only")
{
fnEnablePrinterAdditionalPrinterInfo(true);
}
}
}
break;
case "CollectPrint":
fnDisableChilds("input", vSpanObj, false);
if ( document.getElementById(vRButtonObj.id) != null )
{
document.getElementById(vRButtonObj.id).focus();
}
break;
default:
fnDisableChilds("input", vSpanObj, false);
fnSetFocus2FirstField(vSpanObj, "input");
break;
}
vSpanId  = "fld-" + g_CurRadioButton.substring(4);
vSpanObj = document.getElementById(vSpanId);
if (vSpanObj != null)
{
vSpanObj.disabled = true;
fnDisableChilds("input",  vSpanObj, true);
fnDisableChilds("select", vSpanObj, true);
}
g_CurRadioButton = aNewRadioButton;
}
}
function fnDisableChilds(aTag, aParentObj, aDisable)
{
var vIndex;
var ObjList;
vObjList = aParentObj.all.tags(aTag);
vIndex   = 0;
while (vIndex < vObjList.length)
{
vObjList[vIndex].disabled = aDisable;
vIndex ++;
}
}
function fnSetFocus2FirstField(aParentObj, aTag)
{
var vInputObjList;
vInputObjList = aParentObj.all.tags(aTag);
if (vInputObjList.length > 0)
{
vInputObjList[0].focus();
}
}
function fnTermMailCBSelected()
{
var vInputElement    = window.event.srcElement;
var vInputChecked    = vInputElement.checked;
fnTermMailCBSelectedProcess(vInputChecked);
}
function fnTermMailCBSelectedProcess(aInputChecked)
{
var vSpanId;
var vSpanObj;
vSpanId = "tsm";
vSpanObj = document.getElementById(vSpanId);
if ( aInputChecked == true )
{
vSpanObj.disabled = false;
fnDisableChilds("input",  vSpanObj, false);
fnDisableChilds("textarea",  vSpanObj, false);
document.getElementById("tlb-mf").disabled = false;
}
else
{
vSpanObj.disabled = true;
fnDisableChilds("input", vSpanObj, true);
fnDisableChilds("textarea",  vSpanObj, true);
document.getElementById("tlb-mf").disabled = true;
}
}
function fnTermPrintCBSelected()
{
var vInputElement    = window.event.srcElement;
var vInputChecked    = vInputElement.checked;
fnTermPrintCBSelectedProcess(vInputChecked);
}
function fnTermPrintCBSelectedProcess(aInputChecked)
{
var vSpanId;
var vSpanObj;
vSpanId = "tsp";
vSpanObj = document.getElementById(vSpanId);
if ( vSpanObj != null )
{
if ( aInputChecked == true )
{
vSpanObj.disabled = false;
fnDisableChilds("input",  vSpanObj, false);
fnDisableChilds("textarea",  vSpanObj, false);
if ( document.getElementById("fld-1") != null )
{
document.getElementById("fld-1").disabled = false;
}
if ( document.getElementById("tif-select") != null )
{
document.getElementById("tif-select").disabled = false;
}
}
else
{
vSpanObj.disabled = true;
fnDisableChilds("input", vSpanObj, true);
fnDisableChilds("textarea",  vSpanObj, true);
if ( document.getElementById("fld-1") != null )
{
document.getElementById("fld-1").disabled = true;
}
if ( document.getElementById("tif-select") != null )
{
document.getElementById("tif-select").disabled = true;
}
}
}
}
function fnTermIFClicked(aIFObjId)
{
var vCurObj;
vCurObj = document.getElementById(aIFObjId);
while (vCurObj.tagName != "SPAN")
{
vCurObj = vCurObj.parentElement;
}
if (vCurObj.disabled)
{
fnIgnoreEvent();
}
}
function fnSelectionListEntryChanged(aSelectList)
{
if(aSelectList[aSelectList.selectedIndex].value != "read-only")
{
fnEnablePrinterAdditionalPrinterInfo(true);
}
else
{
fnEnablePrinterAdditionalPrinterInfo(false);
}
}
function fnEnablePrinterAdditionalPrinterInfo(aEnable)
{
var vPrtInpFldObj;
var vPrtLabelFldObj;
vPrtInpFldObj   = document.getElementById("tif-pl");
vPrtLabelFldObj = document.getElementById("prn-0");
if(aEnable)
{
if ( vPrtInpFldObj != null )
{
vPrtInpFldObj.disabled   = false;
vPrtInpFldObj.focus();
}
if ( vPrtLabelFldObj != null )
{
vPrtLabelFldObj.disabled = false;
}
}
else
{
if ( vPrtInpFldObj != null )
{
vPrtInpFldObj.value      = "";
vPrtInpFldObj.disabled   = true;
}
if ( vPrtLabelFldObj != null )
{
vPrtLabelFldObj.disabled = true;
}
}
}
function fnWhereToGoTerm(aCurrentId, aBackwardDirection)
{
var vEventhandled = false;
switch(aCurrentId)
{
case "trb-1":
if (aBackwardDirection)
fnSetFocus2NavigationPanel();
else
vEventhandled = true;
break;
case "tb0":
if (aBackwardDirection == false)
fnSetFocus2ButtonPanel();
else
fnSetFocus2NavigationPanel();
break;
case "tif-CopyCnt":
if (aBackwardDirection == false)
fnSetFocus2ButtonPanel();
else
vEventhandled = true;
break;
case "tb1":
if (aBackwardDirection == false)
fnSetFocus2NavigationPanel();
else
fnSetFocus2MainPanel();
break;
case "body":
case "tb2":
if (aBackwardDirection == false)
{
var vCurRadioButtonCnt;
var vRadioButtonObj;
vCurRadioButtonCnt = 1;
vRadioButtonObj    = document.getElementById("trb-" + vCurRadioButtonCnt + "");
while (vRadioButtonObj != null)
{
if (vRadioButtonObj.checked)
{
vRadioButtonObj.focus();
vRadioButtonObj = null;
}
else
{
vCurRadioButtonCnt ++;
vRadioButtonObj = document.getElementById("trb-" + vCurRadioButtonCnt + "");
}
}
}
else
fnSetFocus2ButtonPanel();
break;
default:
vEventhandled = true;
break;
}
return(vEventhandled);
}
