
/*\// -------------------------------------------------------------- */
/*\// Licensed Material - Property of IBM                            */
/*\//                                                                */
/*\// 5655-002                                                       */
/*\//                                                                */
/*\// (C) Copyright IBM Corp. 2003   All Rights Reserved             */
/*\//                                                                */
/*\// US Government Users Restricted Rights - Use, duplication or    */
/*\// disclosure restricted by GSA ASP Schedule Contract with        */
/*\// IBM Corp.                                                      */
/*\// -------------------------------------------------------------- */
EditControl.prototype.doAction=actionMethod;
EditControl.prototype.doSelection=selectMethod;
EditControl.prototype.doInit=initMethod;
EditControl.prototype.doDocComplete = documentCompleteMethod;
EditControl.prototype.doDisplayChanged=displayChangedMethod;
EditControl.prototype.doSpellCheck=spellCheckMethod;
EditControl.prototype.deleteTag = tagDeleteMethod;
EditControl.prototype.getTagContent = tagGetContentMethod;
EditControl.prototype.getWordList=getWordListMethod;
EditControl.prototype.doSleep=sleepMethod;
EditControl.prototype.getText=getHTML;
EditControl.prototype.setText=setHTML;
EditControl.prototype.setFont=setFontMethod;
EditControl.prototype.mapFontSize=mapFontSizeMethod;
EditControl.prototype.doFindText=findTextMethod;
EditControl.prototype.setTBValue=setValueMethod;
EditControl.prototype.getTBValue=getValueMethod;
EditControl.prototype.docComplete=false;
EditControl.prototype.editor = null;
EditControl.prototype.tbID = null;
EditControl.prototype.getEditor=returnEditor;
EditControl.prototype.cancelEditor=removeEditor;
EditControl.prototype.setEditor=updateEditor;
EditControl.prototype.resizeEditor=resizeEditorMethod;
EditControl.prototype.bDisable = false;
EditControl.prototype.bNameDisable = false;
EditControl.prototype.bMaximized = false;
EditControl.prototype.bInEditor = false;
EditControl.prototype.language = null;
EditControl.prototype.initialHeight = null;
EditControl.prototype.initialWidth = null;
EditControl.prototype.windowed = false;
EditControl.prototype.origargs = null;
EditControl.prototype.id = null;
EditControl.prototype.divID = null;
EditControl.prototype.setFocus = setFocusMethod;
EditControl.prototype.bContentChanged = false;
EditControl.prototype.bTitleChanged = false;
EditControl.prototype.bReplaceAfterCancel = false;
EditControl.prototype.bMouseIn = false;
EditControl.prototype.bFontDialog = true;
EditControl.prototype.bFaceSelect = true;
EditControl.prototype.bSizeSelect = true;
EditControl.prototype.bTagSelect = true;
EditControl.prototype.rngBookmark = null;
EditControl.prototype.userTagName = null;
EditControl.prototype.userTagContents = null;
EditControl.prototype.userTagCombi = null;
EditControl.prototype.tableParms = null;
EditControl.prototype.version = 0;
EditControl.prototype.minorVersion = null;
EditControl.prototype.bForceSave = false;
EditControl.prototype.bAutoSpellCheckonOk = false;
EditControl.prototype.bAutoSpellCheckonSave = false;
EditControl.prototype.bSpellCheckFromStart = false;
EditControl.prototype.bSearchFromStart = false;
EditControl.prototype.bFullPaste = false;
EditControl.prototype.bUnderscore = true;
EditControl.prototype.bBold = true;
EditControl.prototype.bItalic = true;
EditControl.prototype.menuItem = new Array();
EditControl.prototype.menuState = new Array();
EditControl.prototype.menuCmd = new Array();
Buffer.prototype.write = writeMethod;
Buffer.prototype.all = allMethod;
Buffer.prototype.createElement = createElementMethod;
Buffer.prototype.free = freeMethod;
var g_count = 0;
var g_keydown = false;
var g_mousedown = false;
var g_Editor = null;
var g_timeout = 0;
var g_id = "";
var g_Buffer = "";
var g_Tags2remove = 0;
var object = "";
function EditControl(theID, height, width, classid, bPreserve)
{
var xEditControl = '<OBJECT style="visibility:hidden; display:none" classid=' + classid + ' height=' + height +' width='+ width + ' id=' + theID +' vspace=5 hspace=5 VIEWASTEXT>'   +
'<PARAM Name="SourceCodePreservation" VALUE=' + bPreserve + '>'  +
'<PARAM Name="ShowBorders" VALUE=' + true + '>'                  +
'<PARAM Name="UseDivOnCarriageReturn" VALUE=' + true + '>'       +
'<PARAM NAME="ActivateDTCs" VALUE="0">'                          +
'</OBJECT>'                                                      +
'<div ID=' + "oDummyEditor_" + theID + ' STYLE="position:relative;display:none;border:0;">'                           +
'<table id=' + "cmeditor_" + theID + ' align="left" frame="void" style="position:relative;visibility:hidden"><tbody>' +
'<iframe STYLE="position:absolute;display:inline;" border="1" height="0" width="0" hspace=5 scrolling="yes" name=' + "dummyEditor_" + theID + '>'   +
'</iframe>'         +
'</tbody></table>'  +
'</div>';
object.write(xEditControl);
this.editor=object.all(theID);
nv = navigator.appVersion;
this.version = parseFloat(nv.substr(nv.indexOf("MSIE ") + 5));
this.minorVersion = navigator.appMinorVersion;
this.tableParms = new Object();
return this;
}
function Buffer(id)
{
if (typeof(id) != "undefined" && document.all(id))
{
g_id = id;
g_Buffer = "&nbsp;";
document.all(g_id).innerHTML = g_Buffer;
}
else
alert("ID name missing or not existing! ID='" + id + "'");
}
function writeMethod(buffer)
{
if (g_Tags2remove > 0)
{
g_Buffer = document.all(g_id).innerHTML;
while (g_Tags2remove > 0)
{
g_Buffer = g_Buffer.substr(0, g_Buffer.lastIndexOf("</"));
g_Tags2remove -= 1;
}
}
g_Buffer += buffer;
}
function allMethod(id)
{
g_Tags2remove = 0;
if (g_Buffer.length)
{
document.all(g_id).innerHTML = g_Buffer;
if (endtags = document.all(g_id).innerHTML.match(/<\x2f/g))
{
if (validTags = g_Buffer.match(/<\x2f/g))
{
g_Tags2remove = endtags.length - validTags.length;
}
}
}
return document.all(id);
}
function createElementMethod(element)
{
return document.createElement(element);
}
function freeMethod(id)
{
thisallidstyle = this.all(id).style;
thisallidstyle.display   = "inline";
thisallidstyle.visibility = "visible";
g_Buffer = "";
}
function setFocusMethod()
{
if (this.version >= 5.5 && this.getEditor().style.visibility == "visible")
this.getEditor().DOM.focus();
}
function resizeEditorMethod()
{
if (g_Editor.bMaximized)
{
edi_obj = g_Editor.getEditor();
var lDivContainer = document.getElementById('editorTableToolbar1');
var lRects1       = lDivContainer.getClientRects()(0);
var lDivContainer = document.getElementById('editorTableToolbar2');
var lRects2       = lDivContainer.getClientRects()(0);
var lDivContainer = document.getElementById('editorTableToolbar3');
var lRects3       = lDivContainer.getClientRects()(0);
var lDiff = (lRects1.bottom - lRects1.top) + (lRects2.bottom - lRects2.top) + (lRects3.bottom - lRects3.top) + 8;
edi_obj.height = tf0.clientHeight - lDiff;
edi_obj.width  = tf0.clientWidth - 10;
eval("div"+ g_Editor.id).scrollIntoView(false);
g_Editor.setFocus();
}
}
function fnHandleKeyEvents(edi)
{
g_keydown = true;
edi_obj = edi.getEditor();
evt = edi_obj.DOM.parentWindow.event;
if (evt)
{
key = evt.keyCode;
switch(key)
{
case 112:
if (edi.origargs.contextHelp == "Y")
{
			 var vCurId = edi.id;
			 vCurId = vCurId.replace(/_/g, "-");
fnShowContextHelp(vCurId.substring(3));
}
else
{
fnShowHelp("IntroductionEditorHelp");
}
break;
case 116:
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
break;
case 86:
if (evt.ctrlKey && !evt.altKey)
{
edi.doAction(DECMD_PASTE, false, null);
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
}
break;
case 82:
if (evt.ctrlKey && !evt.altKey)
{
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
}
break;
case 72:
if (evt.altKey && !evt.ctrlKey)
{
edi_obj.ShowBorders = !edi_obj.ShowBorders;
eval("div" + edi.id).scrollIntoView(false);
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
}
break;
case 71:
if (evt.altKey && !evt.ctrlKey)
{
edi_obj.ShowDetails = !edi_obj.ShowDetails;
eval("div" + edi.id).scrollIntoView(false);
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
}
break;
case 76:
if (evt.altKey && !evt.ctrlKey)
{
eval("div" + edi.id).scrollIntoView(false);
var dialogParms = new Object();
dialogParms.height = "700px";
dialogParms.width = "900px";
dialogParms.fontface = "Verdana";
dialogParms.fontsize = "1em";
dialogParms.text = edi.tableParms.configSection + edi.getText("text/html");
dialogParms.type = "text";
dialogParms.mode = "Modal";
dialogParms.bDisable = true;
dialogParms.language = edi.language;
dialogParms.cancelEvent = "submitLogic";
dialogParms.name = edi.getTBValue("name") + ";DISABLED";
startEditor("HTMLSource", dialogParms);
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
}
break;
case 83:
if (evt.ctrlKey && !evt.altKey)
{
var tbbt = document.getElementById(edi.id+"saveBtn");
if (tbbt != null)
{
if ( tbbt.state != BUTTON_DISABLE )
{
saveEvent(edi);
}
}
}
break;
case 48:
if (evt.altKey && !evt.ctrlKey)
{
if (!edi.bMaximized)
{
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
fnSetFocus2MainPanel();
}
}
break;
case 45:
if (!evt.altKey && !evt.ctrlKey && !evt.shiftKey)
{
button = document.getElementById(edi.id+"ovr");
if (button.disabled)
{
button.disabled = false;
}
else
{
button.disabled = true;
}
}
else if (evt.shiftKey)
{
edi.doAction(DECMD_PASTE, false, null);
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
}
break;
case 27:
button = document.getElementById(edi.id+"bt4");
if (!button)
button = document.getElementById(edi.id+"btcancel");
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
if (button != null)
{
if (!button.disabled)
{
button.onclick();
}
}
break;
case 49:
case 50:
case 51:
case 52:
case 53:
if (edi.windowed)
{
key--;
}
if (evt.altKey && !evt.ctrlKey)
{
var vBtNr = key-48;
button = document.getElementById(edi.id+"bt"+vBtNr+"");
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
if (button != null)
{
if (!button.disabled)
{
button.onclick();
}
}
}
break;
case 57:
if (evt.altKey && !evt.ctrlKey)
{
htmlSource = document.body.outerHTML;
var WshShell = new ActiveXObject("WScript.Shell");
WshSysEnv = WshShell.Environment("PROCESS");
var fso = new ActiveXObject("Scripting.FileSystemObject");
var a = fso.CreateTextFile(WshSysEnv("TEMP") + "\\HTMLContent.txt", true);
a.WriteLine(htmlSource);
a.Close();
WshShell.Run ("notepad.exe " + WshSysEnv("TEMP") + "\\HTMLContent.txt");
evt.returnValue = false;
evt.cancelBubble = true;
evt.keyCode = 0;
}
break;
default:
break;
}
}
}
function fnEdiMouseDown(edi)
{
edi_obj = edi.getEditor();
evt = edi_obj.DOM.parentWindow.event;
if (!g_mousedown)
{
if (edi_obj.DOM.selection.type != "Control")
{
edi.rngBookmark = edi_obj.DOM.selection.createRange().getBookmark();
}
g_mousedown = true;
}
}
function fnEdiMouseUp(edi)
{
edi_obj = edi.getEditor();
evt = edi_obj.DOM.parentWindow.event;
if (evt.srcElement.disabled || evt.srcElement.contentEditable == "false")
{
if (edi_obj.DOM.selection.type != "Control")
{
rng = edi_obj.DOM.selection.createRange();
if (evt.srcElement.disabled)
{
rng.moveToBookmark(edi.rngBookmark);
}
else
{
			
			 rng.collapse(false);
			 rng.move("character", -1);
}
rng.select();
}
}
g_mousedown = false;
}
function mapFontSizeMethod(selectVal)
{
switch(selectVal)
{
case "1" :  rselectVal = "8";   break;
case "2" :  rselectVal = "10";  break;
case "3" :  rselectVal = "12";  break;
case "4" :  rselectVal = "14";  break;
case "5" :  rselectVal = "18";  break;
case "6" :  rselectVal = "24";  break;
case "7" :  rselectVal = "36";  break;
case "8" :  rselectVal = "1" ;  break;
case "10":  rselectVal = "2" ;  break;
case "12":  rselectVal = "3" ;  break;
case "14":  rselectVal = "4" ;  break;
case "18":  rselectVal = "5" ;  break;
case "24":  rselectVal = "6" ;  break;
case "36":  rselectVal = "7" ;  break;
default:
rselectVal = "10";
}
return rselectVal;
}
function setValueMethod(id, value, bDisabled)
{
tBar = object.all(this.tbID);
for (table = 0; table<tBar.children.length; table++)
{
tbTable = tBar.children[table];
tbRow = tbTable.rows[0];
if (!tbRow)
continue;
for (i=0; i<tbRow.children.length; i++)
{
btn = tbRow.children[i].children[0];
if (!btn)
continue;
if (btn.btnID == tBar.editorID + id)
{
btn.btnType = Number(btn.btnType);
switch (btn.btnType)
{
case BTNTYPE_ACTION:
break;
case BTNTYPE_DIALOGACTION:
break;
case BTNTYPE_MULTIACTION:
break;
case BTNTYPE_SELECT:
if (value == null || value.length == 0)
{
btn.options.length = 0;
}
else
{
	                    for (j=0; j<value.length; j++)
	                    {
	                        bFound = false;
	                        selectVal = value[j];
	
	                        for (k=0; k<btn.options.length; k++)
	                        {
	                            if (selectVal != null && selectVal.toUpperCase() == btn.options[k].text.toUpperCase())
	                            {
	                                bFound = true;
	                                btn.selectedIndex = k;
	                                break;
	                            }
	                        }
	
	                        if (!bFound && selectVal != null)
	                        {
	
	                            newItem = object.createElement("OPTION");
	                            newItem.text = selectVal;
	                            btn.options.add(newItem);
	                            btn.selectedIndex = btn.options.length-1;
	                        }
	                    }
}
break;
case BTNTYPE_EDIT:
if (btn.actionID < MYCMD_PRIVATE)
{
break;
}
else
{
btn.innerText = value;
btn.disabled = bDisabled;
}
break;
default:
alert("default");
break;
}
}
}
}
}
function getValueMethod(id)
{
var value = "";
tBar = object.all(this.tbID);
for (table = 0; table<tBar.children.length; table++)
{
tbTable = tBar.children[table];
tbRow = tbTable.rows[0];
for (i=0; i<tbRow.children.length; i++)
{
btn = tbRow.children[i].children[0];
if (!btn)
continue;
if (btn.btnID == tBar.editorID + id)
{
btn.btnType = Number(btn.btnType);
switch (btn.btnType)
{
case BTNTYPE_ACTION:
value = null;
break;
case BTNTYPE_DIALOGACTION:
value = null;
break;
case BTNTYPE_MULTIACTION:
value = null;
break;
case BTNTYPE_SELECT:
value = null;
break;
case BTNTYPE_EDIT:
value = btn.value;
break;
default:
break;
}
}
}
}
return value;
}
function sleepMethod(sleep)
{
d = new Date();
t = d.getTime() + sleep;
while (d.getTime() < t)
{
d = new Date();
}
}
function getWordListMethod(word)
{
if (gTopObj.applet)
wordlist = fnTalkToServlet("cm=spellcheck", "text=" + word);
else
wordlist = "APPLETERROR: Spellcheck applet not loaded!";
return wordlist;
}
function spellCheckMethod(webEditor, bAutoSpellCheck)
{
var vModalDialogUrlPath;
ec = this.getEditor()
var skiplist = new String("");
var wordlist = new String("");
var input = new String("");
var action = new String("");
var rng = null;
punctuationchars = " !?\u0191.,;:(){}[]<>/-+@\u20ac\u0163\u0165$&=|_\"\'\n\r";
if (ec.DOM.selection.type == "Control")
{
ec.DOM.selection.empty();
}
if (bAutoSpellCheck)
{
rng = ec.DOM.body.createTextRange();
}
else
{
rng = ec.DOM.selection.createRange();
}
rng.collapse();
while (rng.expand("word"))
{
word = rng.text;
word = word.replace(/ /g, "");
if (rng.parentElement().disabled || rng.parentElement().contentEditable == "false" ||
word.length < 2 || punctuationchars.indexOf(word.substr(0, 1)) >= 0)
{
rng.move("word");
continue;
}
rng.findText(word, 1, 0);
rng.select();
if (skiplist.indexOf(word + ";") < 0)
{
wordlist = this.getWordList(word);
if (wordlist.toUpperCase().indexOf("APPLETERROR") >= 0)
{
alert(wordlist);
break;
}
if (wordlist.length > 0 && wordlist != "!")
{
if (wordlist == "?")
wordlist = "";
var leftpx = event.screenX;
var toppx = event.screenY;
var spellParms = new Object();
spellParms.language = webEditor.language;
spellParms.word = word;
spellParms.wordlist = wordlist;
vModalDialogUrlPath = fnGetCurrentLocationUrlPath(this.name,"/html/docspellcheck.htm");
input = showModalDialog( vModalDialogUrlPath, spellParms,"font-family:Verdana; font-size:1em; dialogWidth:390px; dialogHeight:230px; dialogTop:" + toppx + "px; dialogLeft:" + leftpx +"px; center:no; status:no; help:no; scroll:no" );
if (typeof(input) != "undefined")
{
action = input.substr(0,1);
input = input.substr(2);
}
else
{
rng.collapse(false);
rng.select();
fnShowMsg(fnFormatMsg("DOC8060I"));
return;
}
if (input != null)
{
switch (action)
{
case "1":
if (rng.text != input)
rng.text = input;
break;
case "2":
if (rng.text != input)
{
rng.text = input;
bookmark = rng.getBookmark();
while (rng.findText(word, 1, 2))
{
		              if (rng.parentElement().disabled || rng.parentElement().contentEditable == "false")
{
rng.move("word");
continue;
}
rng.text = input;
}
rng.moveToBookmark(bookmark);
}
break;
case "3":
break;
case "4":
skiplist += word + ";";
break;
default:
alert("Error occurred: " + action + ", " + input);
break;
}
}
}
}
rng.move("word");
}
rng.collapse(false);
rng.select();
if (typeof(input) == "object")
{
fnShowMsg(fnFormatMsg("DOC8061I"));
}
else
{
fnShowMsg(fnFormatMsg("DOC8060I"));
}
return;
}
function findTextMethod(rng, sText)
{
if (rng.findText(sText, 1, 0)==true)
{
rng.select();
rng.scrollIntoView();
return true;
}
else
return false;
}
function setFontMethod(fName, fSize)
{
ec = this.getEditor();
if (ec.DOM.all.tags("BODY").length > 0 && (ec.DOM.body.all.tags("DIV").length > 0 || ec.DOM.body.all.tags("FONT").length > 0))
{
return;
}
else
{
content = ec.DOM.body.innerHTML;
ec.DOM.body.innerHTML = "<FONT face=" + fName + " size=" + fSize + ">" + content + "</FONT>";
}
}
function returnEditor()
{
ec = this.editor;
if (ec && this.divID)
ec = eval(ec.id);
return ec;
}
function removeEditor()
{
if (!this.divID)
{
eval("div" + this.id).style.display = "none";
}
else
{
document.getElementById(this.divID).style.display = "none";
document.getElementById(this.divID).style.visibility = "hidden";
document.getElementById(this.divID).innerHTML = "&nbsp;";
}
this.editor = null;
return;
}
function updateEditor(newEditor)
{
this.editor=newEditor;
}
function initMethod(toolbarID, fName, fSize)
{
this.tbID=toolbarID;
this.fontName=fName;
this.fontSize=fSize;
this.docComplete=false;
}
function documentCompleteMethod ()
{
ec = this.getEditor();
if (this.bDisable)
{
ec.DOM.body.contentEditable = false;
ec.DOM.body.style.color = "gray";
}
if (ec.DOM.body.all.tags("CONFIGSECTION").length > 0)
{
var bValid = true;
if (ec.DOM.body.all.tags("CONFIGSECTION")(0).editable == "N")
ec.DOM.body.contentEditable = false;
else
ec.DOM.body.contentEditable = true;
if (ec.DOM.body.all.tags("CONFIGSECTION")(0).fullpaste == "Y")
this.bFullPaste = true;
else
this.bFullPaste = false;
if (ec.DOM.body.all.tags("CONFIGSECTION")(0).autospellcheckonok == "Y")
this.bAutoSpellCheckonOk = true;
else
this.bAutoSpellCheckonOk = false;
if (ec.DOM.body.all.tags("CONFIGSECTION")(0).autospellcheckonsave == "Y")
this.bAutoSpellCheckonSave = true;
else
this.bAutoSpellCheckonSave = false;
if (ec.DOM.body.all.tags("CONFIGSECTION")(0).spellcheckfromstart == "Y")
this.bSpellCheckFromStart = true;
else
this.bSpellCheckFromStart = false;
if (ec.DOM.body.all.tags("CONFIGSECTION")(0).searchfromstart == "Y")
this.bSearchFromStart = true;
else
this.bSearchFromStart = false;
i = 0;
userTagArray = new Array("");
this.userTagName = new Array("SPAN");
this.userTagContents = new Array("");
this.userTagCombi = new Array(false);
while(ec.DOM.body.all.tags("USERTAG").length > i)
{
userTagArray[i] = ec.DOM.body.all.tags("USERTAG")(i).name;
this.userTagName[i+1] = ec.DOM.body.all.tags("USERTAG")(i).outputtag;
this.userTagContents[i+1] = "";
if (ec.DOM.body.all.tags("USERTAG")(i).contents == "innerHTML")
{
var srcIndex = ec.DOM.body.all.tags("USERTAG")(i).sourceIndex + 1;
this.userTagCombi[i+1] = true;
while(ec.DOM.all.item(srcIndex).outerHTML != "</USERTAG>")
{
this.userTagContents[i+1] += ec.DOM.all.item(srcIndex).outerHTML;
srcIndex++;
}
}
else
{
this.userTagCombi[i+1] = false;
this.userTagContents[i+1] = ec.DOM.body.all.tags("USERTAG")(i).contents;
}
i++;
}
this.setTBValue("userTags", userTagArray, this.bDisable);
if (ec.DOM.body.all.tags("FONTDEFINITION").length > 0)
{
if (ec.DOM.body.all.tags("FONTDEFINITION")(0).fontdialog == "N")
{
this.bFontDialog = false;
}
else if (ec.DOM.body.all.tags("FONTDEFINITION")(0).fontdialog == "H")
{
this.bFontDialog = -(true);
}
if (ec.DOM.body.all.tags("FONTDEFINITION")(0).faceselect == "N")
{
this.bFaceSelect = false;
}
else if (ec.DOM.body.all.tags("FONTDEFINITION")(0).faceselect == "H")
{
this.bFaceSelect = -(true);
}
if (ec.DOM.body.all.tags("FONTDEFINITION")(0).sizeselect == "N")
{
this.bSizeSelect = false;
}
else if (ec.DOM.body.all.tags("FONTDEFINITION")(0).sizeselect == "H")
{
this.bSizeSelect = -(true);
}
if (ec.DOM.body.all.tags("FONTDEFINITION")(0).pointsize != null)
{
var vText = ec.DOM.body.all.tags("FONTDEFINITION")(0).pointsize;
vText = vText.replace(/ /g, "");
fontSizeArray = vText.split(";");
for (i=0; i < fontSizeArray.length; i++)
{
switch (fontSizeArray[i])
{
case "8":
case "10":
case "12":
case "14":
case "18":
case "24":
case "36":
break;
default:
bValid = false;
break;
}
}
if (bValid)
{
	            this.setTBValue("fontSizeSelect", null, this.bDisable);
	            this.setTBValue("fontSizeSelect", fontSizeArray, this.bDisable);
	         }
}
i = 0;
fontTagArray = new Array();
while(ec.DOM.body.all.tags("FONTTAG").length > i)
{
fontTagArray[i] = ec.DOM.body.all.tags("FONTTAG")(i).name;
i++;
}
this.setTBValue("fontSelect", fontTagArray, this.bDisable);
}
if (ec.DOM.body.all.tags("TABLEDEFINITION").length > 0)
{
this.tableParms.width =  ec.DOM.body.all.tags("TABLEDEFINITION")(0).width;
this.tableParms.border =  ec.DOM.body.all.tags("TABLEDEFINITION")(0).border;
this.tableParms.borderColor = ec.DOM.body.all.tags("TABLEDEFINITION")(0).borderColor;
this.tableParms.cellPadding = ec.DOM.body.all.tags("TABLEDEFINITION")(0).cellPadding;
this.tableParms.cellSpacing = ec.DOM.body.all.tags("TABLEDEFINITION")(0).cellSpacing;
this.tableParms.caption = ec.DOM.body.all.tags("TABLEDEFINITION")(0).caption;
this.tableParms.attributes = ec.DOM.body.all.tags("TABLEDEFINITION")(0).attributes;
if ((this.tableParms.extendeddialog = ec.DOM.body.all.tags("TABLEDEFINITION")(0).extendeddialog) != "Y")
{
if ((this.tableParms.cols = ec.DOM.body.all.tags("TABLE")(0).rows(0).cells.length) > 0)
{
i = 0;
this.tableParms.cellAttrs = new Array("");
while(i < this.tableParms.cols)
{
cellAttrs = ec.DOM.body.all.tags("TABLE")(0).rows(0).cells(i).outerHTML;
cellAttrs = cellAttrs.substr(cellAttrs.indexOf("<TD") + 3);
cellAttrs = cellAttrs.substr(0, cellAttrs.indexOf(">"));
this.tableParms.cellAttrs[i] = cellAttrs;
i++;
}
}
}
}
if (ec.DOM.body.all.tags("BUTTONS").length > 0)
{
if (ec.DOM.body.all.tags("BUTTONS")(0).underscore == "N")
{
this.bUnderscore = false;
}
else if (ec.DOM.body.all.tags("BUTTONS")(0).underscore == "H")
{
this.bUnderscore = -(true);
}
if (ec.DOM.body.all.tags("BUTTONS")(0).bold == "N")
{
this.bBold = false;
}
else if (ec.DOM.body.all.tags("BUTTONS")(0).bold == "H")
{
this.bBold = -(true);
}
if (ec.DOM.body.all.tags("BUTTONS")(0).italic == "N")
{
this.bItalic = false;
}
else if (ec.DOM.body.all.tags("BUTTONS")(0).italic == "H")
{
this.bItalic = -(true);
}
if (ec.DOM.body.all.tags("BUTTONS")(0).tagselect == "N")
{
this.bTagSelect = false;
}
else if (ec.DOM.body.all.tags("BUTTONS")(0).tagselect == "H")
{
this.bTagSelect = -(true);
}
}
this.deleteTag("CONFIGSECTION");
if (!bValid)
{
alert("Invalid pointsize attribute in FONTDEFINITION tag!");
}
}
if (ec.DOM.body.all.tags("FORM").length &&
(ec.DOM.body.all.tags("FORM")(0).oname == "ALTGRUP" || ec.DOM.body.all.tags("FORM")(0).oname == "SELGRUP"))
{
this.bForceSave = true;
}
if (ec.DOM.selection.type == "Control")
{
ec.DOM.selection.empty();
}
this.rngBookmark = ec.DOM.selection.createRange().getBookmark();
ec.DocumentHTML = ec.DOM.body.outerHTML;
}
function tagDeleteMethod(tagName)
{
var tagBeginIndex = 0;
ec = this.getEditor();
if (ec.DOM.all.tags(tagName).length > 0)
{
tagBeginIndex = ec.DOM.all.tags(tagName)(0).sourceIndex;
if (ec.DOM.all.tags("/"+tagName).length > 0)
{
while (ec.DOM.all.tags("/"+tagName).length > 0)
{
ec.DOM.all.item(tagBeginIndex).outerHTML = "";
}
}
else
{
ec.DOM.all.item(tagBeginIndex).outerHTML = "";
}
}
}
function tagGetContentMethod(tagName)
{
var tagBeginIndex = 0;
var tagContent = "";
ec = this.getEditor();
if (ec.DOM.all.tags(tagName).length > 0)
{
tagBeginIndex = ec.DOM.all.tags(tagName)(0).sourceIndex;
if (ec.DOM.all.tags("/"+tagName).length > 0)
{
var startPos = ec.DOM.all.item(0).outerHTML.indexOf(tagName)-1;
var endPos = ec.DOM.all.item(0).outerHTML.indexOf("/"+tagName) + tagName.length + 2;
tagContent = ec.DOM.all.item(0).outerHTML.substring(startPos, endPos);
}
else
{
tagContent = ec.DOM.all.item(tagBeginIndex).outerHTML;
}
}
return tagContent;
}
function getHTML(type)
{
ec = this.getEditor()
if (!this.docComplete)
return "";
if (ec.Busy == false)
{
if (type == "text/html")
{
i = 0;
while(ec.DOM.body.all.tags("LI").length > i)
{
ec.DOM.body.all.tags("LI")(i).outerHTML = ec.DOM.body.all.tags("LI")(i).outerHTML.replace(/<OL/, "</LI><OL");
ec.DOM.body.all.tags("LI")(i).outerHTML = ec.DOM.body.all.tags("LI")(i).outerHTML.replace(/<UL/, "</LI><UL");
if (ec.DOM.body.all.tags("LI")(i).outerHTML.indexOf("/LI") < 0)
{
ec.DOM.body.all.tags("LI")(i).outerHTML += "</LI>";
}
i++;
}
htmlText = ec.DOM.body.innerHTML;
}
else
htmlText = ec.DOM.body.innerText;
return htmlText;
}
}
function setHTML(type,data)
{
bSuccess = false;
ec = this.getEditor()
if (!this.docComplete)
{
;
}
else if (!ec.Busy)
{
var tagName = "CONFIGSECTION";
var startPos = data.indexOf(tagName)-1;
var endPos = data.indexOf("/"+tagName) + tagName.length + 2;
switch (type)
{
case "text/html":
ec.DOM.body.innerHTML = data;
break;
case "file/html":
var fso = new ActiveXObject("Scripting.FileSystemObject");
var a = fso.OpenTextFile(data, 1, false, -1);
data = a.ReadLine();
a.Close();
ec.DOM.body.innerHTML = data;
startPos = data.indexOf(tagName)-1;
endPos = data.indexOf("/"+tagName) + tagName.length + 2;
break;
case "text/xml":
var xml = new ActiveXObject("Microsoft.XMLDOM");
xml.async = false;
xml.load(data);
if (xml.childNodes.length > 2)
{
xslsplit = xml.childNodes.item(1).nodeValue.split("/");
xsldir = xslsplit[xslsplit.length-2].substr(0, xslsplit[xslsplit.length-2].length);
xslfile = xslsplit[xslsplit.length-1].substr(0, xslsplit[xslsplit.length-1].length-1);
var xsl = new ActiveXObject("Microsoft.XMLDOM");
xsl.async = false;
xslurl = data.replace(/servlet/, xsldir + "/" + xslfile);
xslurl = xslurl.substr(0, xslurl.indexOf("?"));
xsl.load(xslurl);
ec.DOM.body.innerHTML = xml.transformNode(xsl.documentElement);
}
else
{
if (xml.documentElement)
{
alert("No XSL entry found. Showing XML text content now!");
ec.DOM.body.innerText = xml.documentElement.text;
}
else
{
ec.DOM.body.innerText = data;
}
}
break;
default:
ec.DOM.body.innerText = data;
}
bSuccess = true;
if (startPos >= 0 && endPos > startPos)
{
this.tableParms.configSection = data.substring(startPos, endPos);
}
}
return bSuccess;
}
function actionMethod(cmdID, bDialog, value)
{
ec = this.getEditor()
if (ec.QueryStatus(cmdID) != DECMDF_DISABLED || DECMDF_NOTSUPPORTED)
{
if (cmdID == DECMD_INSERTTABLE)
{
var caption = "";
var table = "";
var celltext = "";
if (this.tableParms.extendeddialog && this.tableParms.extendeddialog == "Y")
{
table = value;
}
else
{
if (value.Caption)
{
caption = "<CAPTION>" + value.Caption + "</CAPTION>";
}
table = "<TABLE " + value.TableAttrs + ">" + caption + "<TBODY>";
for (row = 0; row < value.NumRows; row++)
{
table += "<TR>"
for (col = 0; col < value.NumCols; col++)
{
if (this.tableParms.cellAttrs && this.tableParms.cellAttrs[col])
{
table += "<TD " + value.CellAttrs + " " + this.tableParms.cellAttrs[col] + ">" + celltext + "</TD>";
}
else
{
table += "<TD " + value.CellAttrs + ">" + celltext + "</TD>";
}
}
table += "</TR>";
}
table += "</TBODY></TABLE>";
}
rng = ec.DOM.selection.createRange();
rng.pasteHTML(table);
rng.select();
}
else if (!this.bFullPaste && cmdID == DECMD_PASTE)
{
var clipData = window.clipboardData.getData("Text");
rng = ec.DOM.selection.createRange();
rng.text = clipData;
rng.select();
}
else
{
ec.ExecCommand(cmdID, bDialog, value);
if (ec.DOM.selection.type == "Control")
{
ec.DOM.selection.empty();
}
rng = ec.DOM.selection.createRange();
rng.select();
}
}
this.doDisplayChanged(true);
this.setFocus();
}
function selectMethod(id,value,index)
{
ec = this.getEditor()
if (id == DECMD_SETFONTSIZE)
{
value = this.mapFontSize(value);
}
else if (id == MYCMD_TAG_TEXT)
{
if (ec.DOM.selection.type == "Control")
{
ec.DOM.selection.empty();
}
rng = ec.DOM.selection.createRange();
if (rng.text.length == 0 && value.length > 0)
{
rng.expand("word");
}
txtlength = rng.text.length;
if ((txtlength > 0 || typeof(this.userTagContents[index]) != "undefined") && index > 0)
{
if (typeof(this.userTagContents[index]) == "undefined")
{
color = ec.ExecCommand(DECMD_GETBACKCOLOR);
if (color != "#DCDCDC")
{
color = "#DCDCDC";
}
else
{
color = "#C0C0C0";
}
text = "<" + this.userTagName[index] + " style=\"background-color: " + color + ";\" id=\"usertag\" class=\"" + value + "\" name=\"" + value + "\">" + rng.htmlText;
}
else
{
rng.collapse(true);
			
if (this.userTagCombi[index] == true)
{
text = "<" + this.userTagName[index] + " id=\"usertag\" name=\"" + value + "\" contents=\"Y\">" + this.userTagContents[index];
}
else
{
text = "<" + this.userTagName[index] + " id=\"usertag\" class=\"combo\" name=\"" + value + "\" contents=\"Y\">" + this.userTagContents[index];
}
}
if (this.userTagName[index] != "HR")
{
text += "</" + this.userTagName[index] + ">";
}
{
rng.pasteHTML(text);
rng.select();
}
this.doDisplayChanged(true);
this.setFocus();
return true;
}
else
{
tag = rng.parentElement();
while (tag != null)
{
if (tag.tagName == "BODY")
{
for(i=1; i++; i < tag.children.length)
{
if (tag.children[i] == null)
{
break;
}
else if (tag.children[i].id == "usertag")
{
tag = tag.children[i];
break;
}
}
}
if (tag.id == "usertag")
{
selectVal = tag.name;
if (tag.contents == "Y")
{
text = "";
}
else
{
text = tag.outerHTML;
text = text.substr(text.indexOf(">")+1);
text = text.substr(0, text.lastIndexOf("</"));
}
tag.outerHTML = text;
break;
}
tag = tag.parentElement;
}
this.doDisplayChanged(true);
this.setFocus();
return false;
}
}
this.doAction(id, OLECMDEXECOPT_DODEFAULT, value);
}
function displayChangedMethod(handleEvent)
{
if (!(ec = this.getEditor()))
return;
this.bContentChanged = this.bForceSave | ec.IsDirty;
if (!handleEvent && (g_keydown || this.bMouseIn))
{
return;
}
tBar = object.all(this.tbID);
if (tBar)
{
var s = 0;
for (table = 0; table<tBar.children.length; table++)
{
tbTable = tBar.children[table];
tbRow = tbTable.rows[0];
for (i=0; i<tbRow.children.length; i++)
{
btn = tbRow.children[i].children[0];
if (!btn)
continue;
btn.btnType = Number(btn.btnType);
switch (btn.btnType)
{
case BTNTYPE_ACTION:
if (btn.actionID < MYCMD_PRIVATE)
{
s=ec.QueryStatus(btn.actionID);
if (s  == DECMDF_DISABLED || s == DECMDF_NOTSUPPORTED)
actnBtnSetState(btn, BUTTON_DISABLE);
else if (s == DECMDF_ENABLED || s == DECMDF_NINCHED)
actnBtnSetState(btn, BUTTON_OFF);
else
actnBtnSetState(btn, BUTTON_ON);
}
break;
case BTNTYPE_DIALOGACTION:
if (btn.actionID < MYCMD_PRIVATE)
{
s = ec.QueryStatus(btn.actionID);
if (s  == DECMDF_DISABLED || s == DECMDF_NOTSUPPORTED)
actnBtnSetState(btn, BUTTON_DISABLE);
else if (s == DECMDF_ENABLED || s == DECMDF_NINCHED)
actnBtnSetState(btn, BUTTON_OFF);
}
break;
case BTNTYPE_MULTIACTION:
if (btn.actionID < MYCMD_PRIVATE)
{
bIsOn = false;
statusList = new Array(btn.idList.length);
for (j=0; j<btn.idList.length; j++)
{
statusList[j] = ec.QueryStatus(btn.idList[j]);
if (statusList[j] == DECMDF_LATCHED)
{
btn.index = j;
bIsOn = true;
break;
}
}
if (!bIsOn)
{
bIsEnabled = false;
for (j=0; j<statusList.length; j++)
{
if (statusList[j] == DECMDF_ENABLED || DECMDF_NINCHED)
{
btn.index = 0;
actnBtnSetState(btn, BUTTON_OFF);
bIsEnabled = true;
break;
}
}
if (!bIsEnabled)
actnBtnSetState(btn, BUTTON_DISABLE);
}
else
{
if (btn.index == 0)
actnBtnSetState(btn, BUTTON_OFF);
else
actnBtnSetState(btn, BUTTON_ON);
}
}
break;
case BTNTYPE_SELECT:
btn.disabled = this.bDisable;
bFound = false;
if (btn.actionID < MYCMD_PRIVATE)
{
var cmdID;
s = ec.QueryStatus(btn.actionID);
if (s  == DECMDF_DISABLED || s == DECMDF_NOTSUPPORTED)
btn.disabled = true;
if (btn.actionID == DECMD_SETFONTNAME)
{
cmdID = DECMD_GETFONTNAME;
btn.disabled |= (this.bFaceSelect <= 0);
				
				
				
				            if (this.bFaceSelect < 0)
				            {
				               btn.style.visibility="hidden";
				            }
}
else if (btn.actionID == DECMD_SETFONTSIZE)
{
cmdID = DECMD_GETFONTSIZE;
btn.disabled |= (this.bSizeSelect <= 0);
				
				
				
				            if (this.bSizeSelect < 0)
				            {
				               btn.style.visibility="hidden";
				            }
}
else
{
cmdID = btn.actionID;
}
selectVal = ec.ExecCommand(cmdID, OLECMDEXECOPT_DODEFAULT);
if (selectVal != null && cmdID == DECMD_GETFONTSIZE)
{
selectVal = this.mapFontSize(selectVal.toString());
}
}
else
{
selectVal = null;
if (btn.actionID == MYCMD_TAG_TEXT)
{
btn.disabled |= (this.bTagSelect <= 0);
				
				
				
				            if (this.bTagSelect < 0)
				            {
				               btn.style.visibility="hidden";
				            }
selectVal = "";
{
if (ec.DOM.selection.type == "Control")
{
ec.DOM.selection.empty();
}
else
{
									rng = ec.DOM.selection.createRange();
									tag = rng.parentElement();
									while (tag != null)
									{
										if (tag.id == "usertag")
										{
											selectVal = tag.name;
											break;
										}
										tag = tag.parentElement;
									}
								}
}
}
}
for (k=0; k<btn.options.length; k++)
{
if (selectVal != null && selectVal.toUpperCase() == btn.options[k].text.toUpperCase())
{
bFound = true;
btn.selectedIndex = k;
break;
}
}
if (!bFound && selectVal != null)
{
newItem = object.createElement("OPTION");
newItem.text = selectVal;
btn.options.add(newItem);
btn.selectedIndex = btn.options.length-1;
}
break;
case BTNTYPE_EDIT:
btn.disabled = this.bDisable | this.bNameDisable;
break;
case BTNTYPE_LABEL:
btn.disabled = this.bDisable;
if (btn.actionID < MYCMD_PRIVATE)
{
s = ec.QueryStatus(btn.actionID);
if (s  == DECMDF_DISABLED || s == DECMDF_NOTSUPPORTED)
btn.disabled = true;
if (btn.actionID == DECMD_SETFONTNAME)
{
btn.disabled |= (this.bFaceSelect <= 0);
		               if (this.bFaceSelect < 0)
			               {
			                  btn.style.visibility="hidden";
}
}
else if (btn.actionID == DECMD_SETFONTSIZE)
{
btn.disabled |= (this.bSizeSelect <= 0);
		                   if (this.bSizeSelect < 0)
			               {
			                  btn.style.visibility="hidden";
			               }
}
}
else if (btn.actionID == MYCMD_EDIT_TEXT)
{
btn.disabled |= this.bNameDisable;
}
else if (btn.actionID == MYCMD_TAG_TEXT)
{
btn.disabled |= (this.bTagSelect <= 0);
if (this.bTagSelect < 0)
		                {
		                   btn.style.visibility="hidden";
		                }
}
break;
default:
break;
}
}
}
}
}
function submitLogic(webEditor, id)
{
if (!webEditor)
{
return false;
}
button = document.getElementById(webEditor.id+id);
switch (button.name)
{
case "buttoncancel":
if (webEditor.windowed)
window.close();
break;
default:
break;
}
return true;
}
function trapDocComplete(webEditor, text, type, bDisable)
{
if (webEditor != null && !webEditor.docComplete)
{
webEditor.docComplete = true;
inputData = text;
if (inputData != null)
{
webEditor.setText(type, inputData);
fName = webEditor.fontName;
fSize = webEditor.fontSize;
var fSize = "0.25em";
webEditor.setFont(fName, fSize);
}
webEditor.doDocComplete();
}
else if (webEditor != null)
{
webEditor.setFocus();
ec = webEditor.getEditor();
rng = ec.DOM.selection.createRange();
rng.moveToBookmark(webEditor.rngBookmark);
if (rng.parentElement())
{
while (rng.parentElement().contentEditable != "true")
{
if (!rng.move("word"))
{
break;
}
}
while(rng.parentElement().contentEditable != "false" && !rng.parentElement().disabled)
{
if (!rng.move("word", -1))
{
break;
}
}
rng.move("word");
}
rng.select();
webEditor.rngBookmark = rng.getBookmark();
webEditor.doDisplayChanged(true);
}
}
function startEditor(editor, args) {
var vText;
var xEditorScripts;
var vClassId = "clsid:2D360201-FFF5-11d1-8D03-00A0C959BC0A";
var bMaximized = false;
var vStr = null;
if (args.mode.toLowerCase() != "inline" && args.mode.indexOf("dialog") <= 0)
{
dialogSettings = "font-family:Verdana; font-size:1.4em; dialogWidth:" + args.width + "; dialogHeight:" + args.height + "; resizable:no; status:no; center:no; scroll:no; help:no";
args.height = String((parseInt(args.height) - 105) / parseInt(args.height) * 100) + "%";
args.width = "100%";
args.windowed = true;
args.divID = null;
switch( args.mode.toLowerCase() )
{
case "modal"    :
showModalDialog("docedit.htm", args, dialogSettings);
return true;
break;
case "modeless" :
showModelessDialog("docedit.htm", args, dialogSettings);
return true;
break;
default:
alert("Wrong mode detected: " + args.mode);
return false;
}
}
if (args.divID)
{
divID = args.divID;
object = new Buffer(divID);
}
else
{
divID = null;
if (parent.frames.length > 0 && parent.frames[0].name.indexOf("dummyEditor") < 0 )
object = eval("parent.frames[0].document");
else
object = eval("document");
if (args.mode.toLowerCase() == "inline" && object.body.innerHTML.search(editor + "tb") > 0) {
alert(editor + " is already active!");
return(eval(editor));
}
}
vText = args.text;
if (vText)
{
if (vText.indexOf("unsafe=\"Y\"") > 0 || args.type == "file/html")
{
vClassId = "clsid:2D360200-FFF5-11d1-8D03-00A0C959BC0A";
}
if (vText.indexOf("maximized=\"Y\"") > 0)
{
bMaximized = true;
}
vText = vText.replace(/\x22/g, "\\\x22");
vText = vText.replace(/\r|\n/g, "");
}
else
{
vText = "";
}
editor = editor.replace(/-/g, "_");
newLanguage = setLanguage(args.language);
tb = editor + "tb";
ea = editor + "ea";
xEditorScripts = "<!-- " + editor + " -->"                                                                               +
"<DIV id=\"div" + editor + "\" style=\"background-color:'#EFEFEF';\">"                            +
'<SCRIPT event=DocumentComplete for=' + ea + '>trapDocComplete(' + editor + ', "' + vText + '", ' + '"' + args.type + '", ' + args.bDisable + ');</SCRIPT>' +
"<SCRIPT event=DisplayChanged for=" + ea + ">return " + editor + ".doDisplayChanged(false);</SCRIPT>"   +
"<SCRIPT event=onkeydown for=" + ea + ">fnHandleKeyEvents(" + editor + ")</SCRIPT>"                     +
"<SCRIPT event=onkeyup for=" + ea + ">if (g_keydown == true) window.clearTimeout(g_timeout); g_timeout = window.setTimeout(\"g_keydown = false; return " + editor + ".doDisplayChanged(true);\", g_paramScreenTimeout);</SCRIPT>"                     +
"<SCRIPT event=onmouseup for=" + ea + ">fnEdiMouseUp(" + editor + ");return " + editor + ".doDisplayChanged(true);</SCRIPT>"                                                                                         +
"<SCRIPT event=onmousedown for=" + ea + ">fnEdiMouseDown(" + editor + ")</SCRIPT>"                      +
"<SCRIPT event=onmouseover for=" + ea + ">" + editor + ".bMouseIn = true; return;</SCRIPT>"             +
"<SCRIPT event=onmouseout for=" + ea + ">" + editor + ".bMouseIn = false; return;</SCRIPT>"             +
"<SCRIPT event=ShowContextMenu for=" + ea + ">fnEdiShowContextMenu(" + editor + ")</SCRIPT>"            +
"<SCRIPT event=ContextMenuAction(itemIndex) for=" + ea + ">fnEdiContextMenuAction(" + editor + ", itemIndex)</SCRIPT>";
object.write(xEditorScripts);
ToolBar(null, tb, editor, newLanguage);
edit = new EditControl(ea, args.height, args.width, vClassId, false);
edit.origargs=args;
edit.id = editor;
edit.divID = divID;
edit.doInit(tb, args.fontface, edit.mapFontSize(args.fontsize));
edit.bDisable = args.bDisable;
edit.language = newLanguage;
edit.initialHeight = args.height;
edit.initialWidth = args.width;
edit.windowed = args.windowed;
if (args.name)
{
args.name = args.name.replace(/&nbsp;/g, " ");
args.name = args.name.replace(/&amp;/g, "&");
args.name = args.name.replace(/&lt;/g, "<");
args.name = args.name.replace(/&gt;/g, ">");
nameParms = args.name.split(";");
if (nameParms.length > 0 && nameParms[nameParms.length-1] == "DISABLED")
edit.bNameDisable = true;
else
edit.bNameDisable = false;
edit.setTBValue("name", args.name.substr(0,args.name.lastIndexOf(";")), edit.bNameDisable);
}
if (args.fontSelect)
edit.setTBValue("fontSelect", args.fontSelect);
if (args.userTags)
edit.setTBValue("userTags", args.userTags);
eval(editor + " = new Object(edit)");
vStr = "<BR>";
vStr += "<TABLE id=\"editorTableToolbar3\" class=\"editortable\" WIDTH=100% BORDER=0 CELLPADDING=2 ><TBODY><TR><TD>";
if (args.bt0Event)
{
btParms = args.bt0Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt0\" name=\"button0\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt0')\"> " + bt0 + " </button>&nbsp;";
}
if (args.bt1Event)
{
btParms = args.bt1Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt1\" name=\"button1\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt1')\"> " + bt1 + " </button>&nbsp;";
}
if (args.bt2Event)
{
btParms = args.bt2Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt2\" name=\"button2\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt2')\"> " + bt2 + " </button>&nbsp;";
}
if (args.bt3Event)
{
btParms = args.bt3Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt3\" name=\"button3\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt3')\"> " + bt3 + " </button>&nbsp;";
}
if (args.bt4Event)
{
btParms = args.bt4Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt4\" name=\"button4\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt4')\"> " + bt4 + " </button>&nbsp;";
}
if (args.bt5Event)
{
btParms = args.bt5Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt5\" name=\"button5\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt5')\"> " + bt5 + " </button>&nbsp;";
}
if (args.bt6Event)
{
btParms = args.bt6Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt6\" name=\"button6\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt6')\"> " + bt6 + " </button>&nbsp;";
}
if (args.bt7Event)
{
btParms = args.bt7Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt7\" name=\"button7\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt7')\"> " + bt7 + " </button>&nbsp;";
}
if (args.bt8Event)
{
btParms = args.bt8Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt8\" name=\"button8\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt8')\"> " + bt8 + " </button>&nbsp;";
}
if (args.bt9Event)
{
btParms = args.bt9Event.split(";");
vStr += "<button " + btParms[1] + " id=\"" + editor + "bt9\" name=\"button9\" type=\"button\" onClick=\"" + btParms[0] + "(" + editor + ", 'bt9')\"> " + bt9 + " </button>&nbsp;";
}
if (args.cancelEvent)
{
vStr += "<button id=\"" + editor + "btcancel\" name=\"buttoncancel\" type=\"button\" onClick=\"" + args.cancelEvent + "(" + editor + ", 'btcancel')\"> " + btCancel + " </button>&nbsp;";
}
vStr +=  "</TD><TD style=text-align:right;>";
vStr += "<input class=\"ovrindicator\" id=\"" + editor + "ovr\" name=\"overwrite\" type=\"text\" size=\"1\" value=\"" + btTextOverwrite + "\" readonly disabled>";
vStr += "</TD></TR></TBODY></TABLE></DIV>";
vStr+=  "<!-- /" + editor + " -->";
object.write(vStr);
if (divID)
{
object.free(divID);
}
edit.getEditor().style.visibility = "visible";
edit.getEditor().style.display = "";
if ( args.freetextlrr == "Y" || (bMaximized && !edit.windowed))
{
tf0.style.left     = "0%";
tf0.style.height   = "100%";
tf0.style.width    = "100%";
tf0.style.overflow = "hidden";
var lDivContainer = document.getElementById('editorTableToolbar1');
var lRects1       = lDivContainer.getClientRects()(0);
var lDivContainer = document.getElementById('editorTableToolbar2');
var lRects2       = lDivContainer.getClientRects()(0);
var lDivContainer = document.getElementById('editorTableToolbar3');
var lRects3       = lDivContainer.getClientRects()(0);
var lDiff = (lRects1.bottom - lRects1.top) + (lRects2.bottom - lRects2.top) + (lRects3.bottom - lRects3.top) + 8;
edit.getEditor().height = tf0.clientHeight - lDiff;
edit.getEditor().width  = tf0.clientWidth - 10;
g_Editor = edit;
edit.bMaximized = true;
for (id=0; id<9; id++)
{
			
			button = document.getElementById(edit.id + "bt" + id);
			
			if (button && button.innerText == btTextMaximize)
			{
button.innerText = btTextMinimize;
			}
}
window.onresize = edit.resizeEditor;
}
eval("div"+ edit.id).scrollIntoView(false);
return edit;
}
function fnEdiContextMenuAction(edi, itemIndex)
{
edi.doAction(edi.menuCmd[itemIndex], OLECMDEXECOPT_DODEFAULT, null);
}
function fnEdiShowContextMenu(edi)
{
edi.getEditor().SetContextMenu(edi.menuItem, edi.menuState);
}
function fnShowMsg(aMessage)
{
var vResponse = processOKDialog("", aMessage, "docinfo.gif", false, false);
}
function fnFormatMsg(msg,parms)
{
var i;
setMsgLanguage(g_languageid);
msg = msg+" "+eval(msg);
if(parms)
{
for(i=0;i<parms.length;i++)
{
msg =msg.replace("%"+i,parms[i]);
}
}
return(msg)
}
function fnXTEscape(asin)
{
	var i;
	var vs = "";
	var vc;
	var CLT = '<';
	var CGT = '>';
	var LT = "&lt;";
	var GT = "&gt;";
	for (i=0; i<asin.length; i++)
	{
		vc = asin.charAt(i);
		switch (vc)
		{
			case CLT:
				vs += LT;
				break;
			case CGT:
				vs += GT;
				break;
			default:
				vs += vc;
		}
	}
	return vs;
}
function fnXTBuildDialogue()
{
	var xc = window.dialogArguments.tableParms.configSection;					
var vTbEditNlsObj =  window.dialogArguments.g_tbEditNlsObj;
	
	
	
	
var xml = new ActiveXObject("MSXML2.DOMDocument");
	xml.async = false;									
	var bXMLOK = xml.loadXML(xc);						
try
{
	if (bXMLOK)											
	{
		var xsl = new ActiveXObject("Microsoft.XMLDOM");	
		var xsl = new ActiveXObject("MSXML2.FreeThreadedDOMDocument");
		xsl.async = false;									
		var bXSLOK = xsl.load("../xsl/doceditordialog.xsl");			
		if (bXSLOK)		
		{
			
			
			
			
var hc =  fnXSLTParameterTransform(xml, xsl, vTbEditNlsObj);
			
			
			document.body.innerHTML = hc;
		}
		else
		{
			alert("Not able to Load XSL - " + xml.parseError + " closing window.");
			window.close();
		}
	}
	else
	{
		alert("Not able to Load XML - " + xml.parseError + " closing window.");
		window.close();
	}
}
catch (Exception)
{
alert("An exception occurred when trying to create the table dialog");
}
window.dialogWidth = document.all.tableform.offsetWidth + 30 + "px";
window.dialogHeight = document.all.tableform.offsetHeight + 80 + "px";
window.dialogLeft = (parseInt(window.dialogLeft) - (screen.width - screen.availWidth)) + "px";
}
function fnXTReturn()
{
	NODECO         = 0;
	FAT            = 1;
	US             = 2;
	USFAT          = 3;
	COLDECO        = -1;
	var NO         = 0;
	var YES        = 1;
	var MAX_COLS   = 4;
	var LEFT       = "-left";
	var RIGHT      = "-right";
	var BOLD       = "-bold";
	var ALIGN      = "-align";
	var C          = "c";
	var NLEFT      = 0;
	var NRIGHT     = 1;
	var sName;
	var sTableName = "";
	var sAlert     = "";
	var iCols;
	var j;
	var alignButtons;
	var nLines;
	aline_1        = new Array();
	aline_n_1      = new Array();
	aline_n        = new Array();
	colAtts        = new Array();
	colPercent     = new Array();
	cArray         = [LEFT, RIGHT, BOLD];
	gdeco          = [NODECO, NODECO, NODECO];
	gLast          = 0;
	g1beforeLast   = 0;
	var sOut;
	var OTABLE0    = "<TABLE width=\"100%\"";
	var OTCOLS     = " cols=\"";
	var OQUOTE     = "\" ";
	var OGT        = ">";
	var OTABLE1    = "</TABLE>";
	var OCAPTION0  = "<CAPTION>";
	var OCAPTION1  = "</CAPTION>";
	gCols = 4;
	window.returnValue = "";
	
	
	
	
	
	
	sTableName = document.forms["tableform"].elements["txTableName"].value;		
	var nLines = document.forms["tableform"].elements["num-lines"].value;			
	ngCols     = document.forms["tableform"].elements["num-cols"].value;			
	
	gLast        = nLines - 0;
	g1beforeLast = nLines - 1;
	
	
	
	if (document.forms["tableform"].elements["fat-0"].checked)
	{
		gdeco[0] += FAT;
	}
	if (document.forms["tableform"].elements["us-0"].checked)
	{
		gdeco[0] += US;
	}
	
	if (document.forms["tableform"].elements["fat-1"].checked)
	{
		gdeco[1] += FAT;
	}
	if (document.forms["tableform"].elements["us-1"].checked)
	{
		gdeco[1] += US;
	}
	
	if (document.forms["tableform"].elements["fat-2"].checked)
	{
		gdeco[2] += FAT;
	}
	if (document.forms["tableform"].elements["us-2"].checked)
	{
		gdeco[2] += US;
	}
	
	
	
	for (iCols = 0; iCols < MAX_COLS; iCols++)
	{
		sName = C + (iCols + 1) + ALIGN;
		alignButtons = document.forms["tableform"].elements[sName];
		colAtts[iCols] = ["", 0];
		for (j=0; j<2; j++)
		{
			if (alignButtons[j].checked)
			{
				colAtts[iCols][0] = alignButtons[j].value;
				break;
			}
		}
		sName = C + (iCols + 1) + BOLD
		if (document.forms["tableform"].elements[sName].checked)
		{
			colAtts[iCols][1] = YES;
		}
	}
	
	
	
	
	sColLayout = fnXTGetColumnLayout();
	var nPercent = 100/gCols;
	sTmp = sColLayout.split("-");
	for (i=0; i<sTmp.length; i++)
	{
		colPercent[i] = sTmp[i]*nPercent;
	}
	
	
	
	sOut = OTABLE0;
	sOut += OTCOLS;
	sOut += ngCols;
	sOut += OQUOTE;
	sOut += OGT;
	if (sTableName != "")
	{
		sOut += OCAPTION0 + fnXTEscape(sTableName) + OCAPTION1;
	}
	sOut += fnXTBody(nLines) + OTABLE1;
	
	window.returnValue = sOut;
	window.close();
	
}
function fnXTBody(nLines)
{
	var OTBODY0    = "<TBODY>";
	var OTBODY1    = "</TBODY>";
	var sBody;
	var i;
	sBody = OTBODY0;;
	for (i=0; i<nLines; i++)
	{
		sBody += fnXTRow(i);
	}
	sBody += OTBODY1;
	return sBody;
}
function fnXTRow(nRow)
{
	var OTR0       = "<TR>";
	var OTR1       = "</TR>";
	var sRow;
	var jCol;
	sRow = OTR0;
	for (jCol = 0; jCol<colPercent.length; jCol++)
	{
if (colPercent[jCol] != 0) {
sRow += fnXTCol(nRow, jCol);
}
	}
	sRow += OTR1;
	return sRow;
}
function fnXTCol(nRow, nColumn)
{
	var OTD0       = "<TD";
	var OTD1       = "</TD>";
	var NBSP       = "&nbsp;";
	var OGT        = ">";
	var sCol;
	var iPos = nRow + 1;
	sCol = OTD0;
	sCol += " width=\"" + colPercent[nColumn] + "%\"";
	sCol += " align=\"" + colAtts[nColumn][0] + "\"";
	sCol += OGT;
	
	if (colAtts[nColumn][1] == FAT)
	{
		sCol += fnXTApplyDeco(NBSP, nColumn, COLDECO);
	}
	switch (iPos)
	{
		case 1:
			sCol += fnXTApplyDeco(NBSP, nColumn, gdeco[0]);
			break;
		case g1beforeLast:
			sCol += fnXTApplyDeco(NBSP, nColumn, gdeco[1]);
			break;
		case gLast:
			sCol += fnXTApplyDeco(NBSP, nColumn, gdeco[2]);
			break;
		default:
			break;
	}
	sCol += OTD1;
	return sCol;
}
function fnXTApplyDeco(asContents, aiColumn, aiDeco)
{
	var OSTRONG0 = "<STRONG>";
	var OSTRONG1 = "</STRONG>";
	var OUS0     = "<U>";
	var OUS1     = "</U>";
	var sRet = "";
	switch (aiDeco)
	{
		case NODECO:
			break;
		case COLDECO:
			if (colAtts[aiColumn][1] == FAT)
			{
				sRet = OSTRONG0 + sRet + OSTRONG1;
			}
			break;
		case FAT:
			if (colAtts[aiColumn][1] != FAT)
			{
				sRet = OSTRONG0 + sRet + OSTRONG1;
			}
			break;
		case US:
			if (colAtts[aiColumn][1] == FAT)
			{
				sRet = OSTRONG0 + sRet + OSTRONG1;
			}
			sRet = OUS0 + sRet + OUS1;
			break;
		case USFAT:
			sRet = OUS0 + OSTRONG0 + sRet + OSTRONG1 + OUS1;
			break;
		default:
			break;
	}
	return sRet;
}
function fnXTGetColumnLayout()
{
	var colButtons;
	var iChecked;
	var i;
	var nColButtons;
	var sColLayout = "";
	
	colButtons = document.forms["tableform"].elements["col-layout"];
	nColButtons = colButtons.length;
	
	
	
	for (i=0; i<nColButtons; i++)
	{
		if (colButtons[i].checked)
		{
			iChecked = i;							
			sColLayout = colButtons[i].value;		
			break;
		}
	}
	return sColLayout;
}
function fnXTCancel()
{
	
var bReally = confirm( window.dialogArguments.g_tbEditNlsObj.QuestionCancel );
	
	if (bReally)									
	{
		window.returnValue = null;					
		window.close();								
	}
}
function fnXTBlur()
{
	MAXLINES       = 12;
	var bError = false;
	var nLines = 0;
var numeric = '^[0-9]$|^[1-9][0-9]+$';
	var sLines = document.forms["tableform"].elements["num-lines"].value;			
	
var vRegExp = new RegExp(numeric);
	var isNumeric = vRegExp.test(sLines);
	if (isNumeric)
	{
		nLines = sLines - 0; 		
		
		if ((nLines == 0) || (nLines > MAXLINES))
		{
			bError = true;
		}
	}
	else
	{
		bError = true;
	}
	
	
	if (bError)
	{
		
var    vRegExp          = new RegExp("\{0\\}","g");
alert(  window.dialogArguments.g_tbEditNlsObj.EnterNumberMessage.replace(vRegExp,MAXLINES));
		document.forms["tableform"].elements["num-lines"].select();			
		document.forms["tableform"].elements["num-lines"].focus();			
	}
}
function fnXSLTParameterTransform(aXmlDoc, aXslDoc, aTbEditNlsObj)
{
var xslt   = new ActiveXObject("MSXML2.XSLTemplate");
var xsltProcessor;
var output;
xslt.stylesheet = aXslDoc;
xsltProcessor = xslt.createProcessor();
xsltProcessor.input = aXmlDoc;
xsltProcessor.addParameter("atnam", aTbEditNlsObj.Tablename      );
xsltProcessor.addParameter("afnam", aTbEditNlsObj.Tableform      );
xsltProcessor.addParameter("anoro", aTbEditNlsObj.Rownumber      );
xsltProcessor.addParameter("afiro", aTbEditNlsObj.Firstrow       );
xsltProcessor.addParameter("anlro", aTbEditNlsObj.Nexttolastrow  );
xsltProcessor.addParameter("alaro", aTbEditNlsObj.Lastrow        );
xsltProcessor.addParameter("aundl", aTbEditNlsObj.Underline      );
xsltProcessor.addParameter("abold", aTbEditNlsObj.Bold           );
xsltProcessor.addParameter("acolu", aTbEditNlsObj.Column         );
xsltProcessor.addParameter("alalg", aTbEditNlsObj.Leftaligned    );
xsltProcessor.addParameter("aralg", aTbEditNlsObj.Rightaligned   );
xsltProcessor.addParameter("abuok", aTbEditNlsObj.ButtonOk       );
xsltProcessor.addParameter("abuca", aTbEditNlsObj.ButtonCancel   );
xsltProcessor.transform();
output = xsltProcessor.output;
return output;
}
