
/*\// -------------------------------------------------------------- */
/*\// Licensed Material - Property of IBM                            */
/*\//                                                                */
/*\// 5655-002                                                       */
/*\//                                                                */
/*\// (C) Copyright IBM Corp. 2003   All Rights Reserved             */
/*\//                                                                */
/*\// US Government Users Restricted Rights - Use, duplication or    */
/*\// disclosure restricted by GSA ASP Schedule Contract with        */
/*\// IBM Corp.                                                      */
/*\// -------------------------------------------------------------- */
function fnPrmPre()
{
fnSetPrmToolTip();
fnSetOnloadFocus();
setTimeout("tb0.doScroll('scrollbarPageLeft')",g_paramScreenTimeout);
return;
}
function fnSetFocusOnInputField(aInputField)
{
var vFocusWasSet = fnSetFocusOnInputField(aInputField, false, 0);
return vFocusWasSet;
}
function fnSetFocusOnInputField(aInputField, aFocusWasSet, aMode)
{
var vFocusWasSet = aFocusWasSet;
if ( ( aInputField != null ) && ( typeof( aInputField.id ) != "undefined" ) )
{
if ( ( aInputField.id.charAt(4) == '0' ) && (aInputField.id.charAt(5) == '0' ) )
{
aInputField.fireEvent("onclick");
aInputField.focus();
vFocusWasSet = true;
}
else
{
vFocusWasSet = false;
}
}
else
{
vFocusWasSet = false;
}
return vFocusWasSet;
}
function fnSetOnloadFocus()
{
var vFocusWasSet     = false;
var vInErrorFound    = false;
var vFields= document.all.tags("input").length;
var vField  = document.all.tags("input");
var i = 0;
var j = 0;
var vDebug = false;
for(i=0;i<vFields;i++)
{
if  ( vField[i].inerror == "1" )
{
if ( vFocusWasSet == false )
{
vInErrorFound = true;
vFocusWasSet =   fnSetFocusOnInputField(vField[i], vFocusWasSet, "1");
}
}
if ( vDebug == true )
{
if ( ( vField[i].id.charAt(9) == "1" ) ||  (vField[i].id.charAt(10) == "1"))
{
alert("field[" + i + "]: PDPArg= " + vField[i].id.charAt(9) + " PVPArg=" + vField[i].id.charAt(10)  + " field[i].inerror = " + field[i].inerror + " field[i].mod=" + field[i].mod);
}
}
}
if ( vInErrorFound == false )
{
j = 0;
vFocusWasSet =  fnSetFocusOnInputField(vField[0], vFocusWasSet, "2");
}
else
{
if ( vFocusWasSet == false )
{
j = 0;
while ( ( j <  vFields ) && ( vFocusWasSet == false ))
{
vFocusWasSet =   fnSetFocusOnInputField(vField[j], vFocusWasSet, "3");
j++;
}
}
}
}
function fnSetPrmToolTip()
{
var msg;
var title;
setMsgLanguage(g_languageid);
fields= document.all.tags("input").length;
field  = document.all.tags("input");
for(i=0;i<fields;i++) {
title="";
title=field[i].mask+" ";
if( field[i].id.charAt(8).toUpperCase()  =="D" )
{
title=title+g_dateformat+" ";
}
if(field[i].id.charAt(3)  =="0") {
if(field[i].mod=="1") {
title=title+g_toolTipObj.prmmandatoryMod+" ";
}else {
title=title+g_toolTipObj.prmmandatory+" ";
}
}
if(field[i].id.charAt(3)  =="1") {
if(field[i].mod=="1") {
title=title+g_toolTipObj.prmmodified+" ";
}else {
title=title+g_toolTipObj.prmcanmodify+" ";
}
}
if(field[i].id.charAt(5)=="1") {
title=title+g_toolTipObj.prmcprotected+" ";
}
if(field[i].id.charAt(4)=="1") {
title=title+g_toolTipObj.prmprotected+" ";
}
if (field[i].id.charAt(9) == "1" )
{
title=title+g_toolTipObj.prmpdparg+" ";
}
if (field[i].id.charAt(10) == "1" )
{
title=title+g_toolTipObj.prmpvparg+" ";
}
field[i].title=title;
}
return(true);
}
function fnIsNumeric(field)
{
var vRegExpString = '^[0-9]+$';
var vRegExp = new RegExp(vRegExpString);
var msg;
setMsgLanguage(g_languageid);
if ( ( vRegExp.test(field.value) == false ) && ( field.value.length != 0 ))
{
fnPrmShowMsg(fnFormatMsg("DOC8050E"));
setTimeout("fnSetFocusOnInputField(field)",g_paramScreenTimeout);
field.select();
return false;
}
return true;
}
function fnIsAlpha(field)
{
setMsgLanguage(g_languageid);
if ((  fnIsAlphaBlankOrSpecialCharacterString(field.value) == false ) && ( field.value.length != 0 ))
{
fnPrmShowMsg(fnFormatMsg("DOC8069E"));
fnSetFocusOnInputField(field);
field.select();
return false;
}
return true;
}
function fnModified(field)
{
var vTrimmedLength =  fnTrimString(field.value).length;
var vOpt           =  field.id.charAt(3);
if(( vOpt =="0" ) && ( vTrimmedLength == 0))
{
field.className  ="mandatory";
if ( field.inerror == "0" )
{
field.mod = "1";
}
return;
}
if(field.imod == true)
{
if (( vOpt == "0" ) || ( vTrimmedLength >  0 ))
{
fnIsFieldSyntacticallyCorrect(field, true);
}
}
field.mod       = "1";
field.className = "modified";
field.id=fnSetCharAt(field.id,7,"1");
fnSetPrmToolTip();
field.imod=false;
}
function fnIsFieldInError(field)
{
var vInError = false ;
if(  field.inerror  == "1" )
{
vInError = true;
}
return vInError;
}
function fnIsFieldSyntacticallyCorrect(field, aTestMandatory)
{
var vIsFieldSyntacticallyCorrect = false;
var vSetInputInError             = false;
var vCorrectType                 = false;
var vCorrectMinimumLength        = false;
var vMandatoryFieldTest          = true;
var vDebug = false;
if ( aTestMandatory == true )
{
if ( field.id.charAt(3) == "0" )
{
if(field.value.length>0)
{
vMandatoryFieldTest = true;
}
else
{
vMandatoryFieldTest = false;
}
}
}
if ( vDebug == true )
{
alert("-A- fnIsFieldSyntacticallyCorrect() aTestMandatory="  + aTestMandatory  + "field.id = " + field.id + " field.inerror = " + field.inerror);
}
switch (  field.id.charAt(8).toUpperCase() )
{
case "N" :
if (fnIsNumeric(field)==false)
{
window.status = "*** field.id = " + field.id + " is a invalid numeric field";
vCorrectType     = false;
vSetInputInError = fnInputInError(field);
}
else
{
vCorrectType = true;
}
break;
case "D" :
if (fnIsDateValid(field)== false)
{
window.status = "*** field.id = " + field.id + " is a invalid date field";
vCorrectType     = false;
vSetInputInError = fnInputInError(field);
}
else
{
vCorrectType = true;
}
break;
case "P" :
if (fnIsMaskValid(field)== false)
{
window.status = "*** field.id = " + field.id + " is a invalid mask field";
vCorrectType     = false;
vSetInputInError = fnInputInError(field);
}
else
{
vCorrectType = true;
}
break;
case "A":
if (fnIsAlpha(field)== false)
{
window.status = "*** field.id = " + field.id + " is a invalid alpha field";
vCorrectType     = false;
vSetInputInError = fnInputInError(field);
}
else
{
vCorrectType = true;
}
break;
case "X":
vCorrectType = true;
break;
default:
vCorrectType = false;
}
if(fnTrimString(field.value).length>0)
{
if (fnHasMinLength(field)==false)
{
window.status = "*** field.id = " + field.id + " has invalid minimum length";
vCorrectMinimumLength = false;
vSetInputInError      = fnInputInError(field);
}
else
{
vCorrectMinimumLength = true;
}
}
else
{
if (  field.id.charAt(3) == "1"   )
{
vCorrectMinimumLength = true;
}
else
{
vCorrectMinimumLength = false;
}
}
field.id=fnSetCharAt(field.id,7,"1")
if ( vDebug == true )
{
alert("vCorrectType = " + vCorrectType + " vCorrectMinimumLength =" + vCorrectMinimumLength + " vMandatoryFieldTest= "  +  vMandatoryFieldTest + " aTestMandatory=" + aTestMandatory);
}
if ( ( vCorrectType == true ) && ( vCorrectMinimumLength == true ) && (vMandatoryFieldTest == true ))
{
vIsFieldSyntacticallyCorrect = true;
if ( aTestMandatory == true )
{
fnInputInErrorOff(field);
if ( vDebug == true )
{
alert("-B- fnIsFieldSyntacticallyCorrect() field.id = " + field.id + " field.inerror = " + field.inerror);
}
}
else
{
if (  field.id.charAt(9) == "0" )
{
fnInputInErrorOff(field);
}
if ( vDebug == true )
{
alert("-C- fnIsFieldSyntacticallyCorrect() field.id = " + field.id + " field.inerror = " + field.inerror);
}
}
}
else
{
if ( vDebug == true )
{
alert("-F- fnIsFieldSyntacticallyCorrect() field.id = " + field.id + " field.inerror = " + field.inerror);
}
vIsFieldSyntacticallyCorrect = false;
}
return vIsFieldSyntacticallyCorrect;
}
function fnLeaveField(field)
{
var vYY ;
var vYYYY;
var vMM ;
var vDD ;
var vFieldDateArray;
var vDatSep;
var twenty = "20";
var vDebug = false;
if ( field.className == "found" )
{
if((field.id.charAt(3)  =="0" ) && ( fnTrimString(field.value).length == 0))
{
field.className  ="mandatory";
}
else
{
if ( field.mod == "1" )
{
field.className = "modified";
}
else
{
field.className  = "default";
}
}
}
if ( (field.id.charAt(8).toUpperCase()  == "D") && (fnTrimString(field.value).length > 0) )
{
if ( vDebug == true )
{
alert("g_dateformat=" + g_dateformat + " g_datzer = " + g_datzer);
}
switch(g_dateformat)
{
case "DD.MM.YY":
vDatSep = ".";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[0],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vYY = vFieldDateArray[2];
window.event.srcElement.value    = vDD.concat(vDatSep,vMM,vDatSep,vYY);
}
break;
case "MM/DD/YY":
vDatSep = "/";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[0],g_datzer);
vYY = vFieldDateArray[2];
window.event.srcElement.value    = vMM.concat(vDatSep,vDD,vDatSep,vYY);
}
break;
case "DD/MM/YY":
vDatSep = "/";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[0],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vYY = vFieldDateArray[2];
window.event.srcElement.value    = vDD.concat(vDatSep,vMM,vDatSep,vYY);
}
break;
case "DD-MM-YY":
vDatSep = "-";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[0],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vYY = vFieldDateArray[2];
window.event.srcElement.value    = vDD.concat(vDatSep,vMM,vDatSep,vYY);
}
break;
case "YY/DD/MM":
vDatSep = "/";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[2],g_datzer);
vYY = vFieldDateArray[0];
window.event.srcElement.value    = vDD.concat(vDatSep,vMM,vDatSep,vYY);
}
break;
case "YY/MM/DD":
vDatSep = "-";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[2],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vYY = vFieldDateArray[0];
window.event.srcElement.value    = vDD.concat(vDatSep,vMM,vDatSep,vYY);
}
break;
case "DD.MM.YYYY":
vDatSep = ".";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[0],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vYY = vFieldDateArray[2];
if ( field.id.charAt(8) == "d" )
{
vYYYY = twenty.concat(vYY);
window.event.srcElement.value = vDD.concat(vDatSep,vMM,vDatSep,vYYYY);
field.id = fnSetCharAt(field.id,8,"D");
}
else
{
window.event.srcElement.value    = vDD.concat(vDatSep,vMM,vDatSep,vYY);
}
}
break;
case "MM/DD/YYYY":
vDatSep = "/";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[0],g_datzer);
vYY = vFieldDateArray[2];
if ( field.id.charAt(8) == "d" )
{
vYYYY = twenty.concat(vYY);
window.event.srcElement.value = vMM.concat(vDatSep,vDD,vDatSep,vYYYY);
field.id = fnSetCharAt(field.id,8,"D");
}
else
{
window.event.srcElement.value    = vMM.concat(vDatSep,vDD,vDatSep,vYY);
}
}
break;
case "DD/MM/YYYY":
vDatSep = "/";
vFieldDateArray= field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[0],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vYY = vFieldDateArray[2];
if ( field.id.charAt(8) == "d" )
{
vYYYY = twenty.concat(vYY);
window.event.srcElement.value = vDD.concat(vDatSep,vMM,vDatSep,vYYYY);
field.id = fnSetCharAt(field.id,8,"D");
}
else
{
window.event.srcElement.value    = vDD.concat(vDatSep,vMM,vDatSep,vYY);
}
}
break;
case "DD-MM-YYYY":
vDatSep = "-";
vFieldDateArray = field.value.split(vDatSep);
if ( vFieldDateArray.length == 3 )
{
vDD = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[1],g_datzer);
vMM = fnRemoveLeadingZeroFromMonthOrDay(vFieldDateArray[0],g_datzer);
vYY = vFieldDateArray[2];
if ( field.id.charAt(8) == "d" )
{
vYYYY = twenty.concat(vYY);
window.event.srcElement.value = vDD.concat(vDatSep,vMM,vDatSep,vYYYY);
field.id = fnSetCharAt(field.id,8,"D");
}
else
{
window.event.srcElement.value    = vDD.concat(vDatSep,vMM,vDatSep,vYY);
}
}
break;
default:
window.event.srcElement.value = field.value;
if ( field.id.charAt(8) == "d" )
{
field.id = fnSetCharAt(field.id,8,"D");
}
break;
}
}
if((field.id.charAt(3)  =="0" ) && ( fnTrimString(field.value).length == 0)) {
field.className  ="mandatory";
}
if(field.name=="last") {
window["tb1"].focus();
}
fnSetGlobalVariable("gContextObj", field.id);
fnSetPrmToolTip();
}
function fnSetCharAt(st,ix,ch)
{
st = st.substring(0,ix)+ch+st.substring(ix+1,st.length);
return(st);
}
function fnFinishPrm()
{
var i               = 0;
var vReturncode     = 0;
var vPDPArgument    = "0";
var vPVPArgument    = "0";
var vOptional       = "0";
var vModified       = "0";
var vCountPDPMndEmptyContent = 0;
var vCountPDPOpt      = 0;
var vCountPDPMnd      = 0;
var vCountPDPMndMod   = 0;
var vCountPDPOptMod   = 0;
var vCountPVPOpt        = 0;
var vCountPVPMnd        = 0;
var vCountPVPMndMod     = 0;
var vCountPVPOptMod     = 0;
var vCountPVPMod        = 0;
var vCountPVPInError    = 0;
var vCountPVPInErrorMod = 0;
var vDebug            = false;/* true in test, false in production */
var vFieldIsInError            = false;
var vPDPNoPVPArgumentFieldIsInError   = false;
var vPDPPVPArgumentFieldIsInError     = false;
var vNoPDPPVPArgumentFieldIsInError   = false;
var vNoPDPNoPVPArgumentFieldIsInError = false;
var vPDPPVP;
var jsave        = 0;
setMsgLanguage(g_languageid);
fields= document.all.tags("input").length;
field  = document.all.tags("input");
if ( vDebug == true )
{
alert("fnFinishPrm() start: g_postpvp=" +  g_postpvp  + " g_pdpcallable=" + g_pdpcallable );
}
i = 0;
while ( i < fields )
{
vPVPArgument = field[i].id.charAt(10);        /* pvpa */
vPDPArgument = field[i].id.charAt(9);
vOptional    = field[i].id.charAt(3);
vModified    = fnIsFieldModified(field[i]);
if ( vDebug == true )
{
if ( ( field[i].id.charAt(9) == "1" ) || ( field[i].id.charAt(10) == "1") )
{
alert("field[" + i + "]: vModified = " + vModified + " vOptional= " + vOptional + " PDPArg= " + vPDPArgument + " PVPArg=" + vPVPArgument  + " field[i].inerror = " + field[i].inerror + " field[i].mod=" + field[i].mod);
}
}
if ( vPVPArgument == "1" )
{
if ( fnIsFieldInError(field[i]) == true )
{
vCountPVPInError++;
if (vModified == true )
{
vCountPVPInErrorMod++;
}
}
if ( vOptional == "0" )
{
vCountPVPMnd++;
if ( vModified == true )
{
vCountPVPMndMod++;
}
}
if ( vOptional == "1" )
{
vCountPVPOpt++;
if ( vModified == true )
{
vCountPVPOptMod++;
}
}
if ( vModified == true )
{
vCountPVPMod++;
}
}
if ( vPDPArgument == "1" )
{
if ( vOptional == "0" )
{
vCountPDPMnd++;
if ( vModified == true )
{
vCountPDPMndMod++;
}
}
if ( vOptional == "1" )
{
vCountPDPOpt++;
if ( vModified == true )
{
vCountPDPOptMod++;
}
}
}
i++;
}
if ( vDebug == true )
{
alert(" vCountPDPOptMod=" +  vCountPDPOptMod + " vCountPDPMndMod= " + vCountPDPMndMod + " g_postpvp=" + g_postpvp + " g_pdpcallable=" + g_pdpcallable);
}
if ( (  vCountPDPMndMod == 0 ) &&
(  vCountPDPOptMod == 0 )  )
{
i=0;
while (i<fields)
{
if ( vDebug == true )
{
alert("=== field[i].id = " +  field[i].id + " field[i].className=" + field[i].className);
}
if (( field[i].id.charAt(3) == "0" ) && ( field[i].id.charAt(4) == "0" ))
{
if( fnTrimString(field[i].value).length == 0)
{
window.status = "*** field with field[i].id = " + field[i].id + " is empty.";
fnPrmShowMsg(fnFormatMsg("DOC8051E"));
setTimeout("fnSetFocusOnInputField(field[" + i + "])",g_paramScreenTimeout);
field[i].select();
return(-1);
}
else
{
if ( vDebug == true )
{
alert("=== field[i].id = " +  field[i].id + " fnTrimString(field[i].value).length = "  +  fnTrimString(field[i].value).length);
}
}
}
if ( ( field[i].id.charAt(3) == "0" ) || ( fnTrimString(field[i].value).length>0 ))
{
if(fnIsFieldSyntacticallyCorrect(field[i], false)==false)
{
if ( vDebug == true )
{
alert("i = " + i  + " field[i].value = " + field[i].value + " fnCheckField returned false Returncode = -2");
}
return(-2);
}
}
i++;
}
for (i=0; i<fields; i++)
{
field[i].imod = true;
if ( fnIsFieldInError(field[i]) == true )
{
if ( vDebug == true )
{
alert("field[ " + i + " ] is in error ! ");
}
vFieldIsInError = true;
vPDPPVP =  field[i].id.charAt(9).concat(field[i].id.charAt(10));
switch(vPDPPVP)
{
case "00":    vNoPDPNoPVPArgumentFieldIsInError = true;  break;
case "10":    vPDPNoPVPArgumentFieldIsInError   = true;  break;
case "01":    vNoPDPPVPArgumentFieldIsInError   = true;  break;
case "11":    vPDPPVPArgumentFieldIsInError     = true;  break;
default:
}
}
}
if (  ( vFieldIsInError == true                    ) &&
( vPDPNoPVPArgumentFieldIsInError == false   ) &&
( vNoPDPNoPVPArgumentFieldIsInError == false ) &&
( vCountPVPMod == 0                          ) &&
( g_postpvp == "1"                           )     )
{
jsave = -1;
for ( i=0; i < fields;i++)
{
if ( ( fnIsFieldInError(field[i]) == true ) &&
( field[i].id.charAt(9).concat(field[i].id.charAt(10)) == "01")     )
{
fnInputInError(field[i]);
if ( jsave == -1 )
{
jsave = i;
fnPrmShowMsg(fnFormatMsg("DOC8066E"));
setTimeout("fnSetFocusOnInputField(field[" + i + "])",g_paramScreenTimeout);
field[i].select();
}
}
}
}
if ( vDebug == true )
{
alert("vFieldIsInError="+ vFieldIsInError
+ " vNoPDPNoPVPArgumentFieldIsInError=" + vNoPDPNoPVPArgumentFieldIsInError
+ " vPDPNoPVPArgumentFieldIsInError="   + vPDPNoPVPArgumentFieldIsInError
+ " vNoPDPPVPArgumentFieldIsInError="   + vNoPDPPVPArgumentFieldIsInError
+ " vPDPPVPArgumentFieldIsInError="     + vPDPPVPArgumentFieldIsInError );
}
if ( vFieldIsInError == true )
{
if ( vPDPNoPVPArgumentFieldIsInError == true )
{
if ( vDebug == true )
{
alert("No PDP Args modified. PDP-No PVP Argument field in error : RC = -3");
}
fnPrmShowMsg(fnFormatMsg("DOC8065E"));
return(-3);
}
else
{
if ( vNoPDPNoPVPArgumentFieldIsInError == true )
{
if ( vDebug == true )
{
alert("No PDP Args modified. No PDP Args in error. A Non-PVP-Non-PDP-Arg field in error : RC = -10");
}
fnPrmShowMsg(fnFormatMsg("DOC8065E"));
return(-10);
}
else
{
if ( vCountPVPMod > 0 )
{
if ( vDebug == true )
{
alert("  ==> Origin=0 Returncode = 0");
}
return 0;
}
else
{
if ( vDebug == true )
{
alert("==> Origin=5 Returncode = 0");
}
return 0;
}
}
}
}
if ( vDebug == true )
{
alert("==> Origin=3 Returncode = 0");
}
return(0);
}
else
{
for(i=0;i<fields;i++)
{
vPDPArgument = field[i].id.charAt(9);
if ( vPDPArgument == "1" )
{
if (( field[i].id.charAt(3) == "0" ) && ( field[i].id.charAt(4) == "0" ))
{
if( fnTrimString(field[i].value).length == 0)
{
vCountPDPMndEmptyContent++;
}
}
if(fnTrimString(field[i].value).length>0)
{
if(fnIsFieldSyntacticallyCorrect(field[i],false)==false)
{
if ( vDebug == true )
{
alert("i = " + i  + " field[i].value = " + field[i].value + " fnCheckField returned false Returncode = -5");
}
return(-5);
}
}
}
}
if ( g_pdpcallable == "0"  )
{
if ( vCountPDPMndEmptyContent > 0 )
{
fnPrmShowMsg(fnFormatMsg("DOC8063E"));
return (-6);
}
else
{
for (i=0; i<fields; i++)
{
field[i].imod = true;
}
if ( vDebug == true )
{
alert("==> Origin=2 Returncode = 0");
}
return 0;
}
}
else
{
if ( ( vCountPDPMndEmptyContent == vCountPDPMnd ) && ( vCountPDPMnd > 0) )
{
fnPrmShowMsg(fnFormatMsg("DOC8064E"));
return (-7);
}
else
{
for (i=0; i<fields; i++)
{
field[i].imod = true;
}
if ( vDebug == true )
{
alert("==> Origin=1 Returncode = 0");
}
return 0;
}
}
}
}
function fnFormatMsg(msg,parms)
{
var i;
var vLanguageId = null;
var vMsgNo      = msg;
var vMsg        = msg;
if ( typeof(g_languageid) == "undefined" )
{
vLanguageId = parent.g_languageid ;
parent.setMsgLanguage(vLanguageId);
vMsg = vMsgNo +" "+eval("parent." + vMsg);
}
else
{
vLanguageId = g_languageid;
setMsgLanguage(vLanguageId);
vMsg = vMsgNo +" "+eval(vMsg);
}
if(parms)
{
for(i=0;i<parms.length;i++)
{
vMsg =vMsg.replace("%"+i,parms[i]);
}
}
return(vMsg);
}
function fnHotKeys(field)
{
var i = 0;
var j = 0;
var k = 0;
var kx =0;
var ix;
var fields;
var ss    ;
var init  ;
var vFocusWasSet = false;
field.imod=true;
if(event.keyCode==8)
{
if(field.readOnly==true)
{
event.cancelBubble = true;
event.returnValue  = false;
event.keyCode      = 0;
}
}
if ( (event.keyCode==40) || (event.keyCode==38))
{
ss   = field.position.split("-");
init = fnGetStartIndexForFocusSetting(event.keyCode, event.shiftKey, ss);
fields=document.getElementsByTagName("INPUT");
ix = init%parseInt(ss[1]);
i = ix;
j = 0;
}
if ( event.keyCode==40 )
{
while (( vFocusWasSet == false ) && ( j < ss[1] ))
{
if ( i > parseInt(ss[1]) )
{
i=0;
}
vFocusWasSet = fnSetFocusOnInputField(fields[i]);
if ( vFocusWasSet == true )
{
fields[ix].select();
}
i++;
j++;
}
}
if ( event.keyCode==38 )
{
while (( vFocusWasSet == false ) && ( j < ss[1] ))
{
if ( i < 0 )
{
i= parseInt(ss[1]);
}
vFocusWasSet = fnSetFocusOnInputField(fields[i]);
if ( vFocusWasSet == true )
{
fields[ix].select();
}
i--;
j++;
}
}
if(event.keyCode==9)
{
ss = field.position.split("-");
fields=document.getElementsByTagName("INPUT");
init = fnGetStartIndexForFocusSetting(event.keyCode, event.shiftKey, ss);
if ( event.shiftKey==true)
{
i = init;
j = 0;
while (j < fields.length)
{
ix = i%parseInt(ss[1]);
kx = ix - 1;
if ( kx < 0 )
{
kx = parseInt(ss[1]) - 1;
}
while (( (fields[kx].id.charAt(4)  =="1") || (fields[kx].id.charAt(5) == "1") ) && ( j < fields.length ))
{
kx--;
j++;
i--;
ix = i%parseInt(ss[1]);
if ( kx < 0  )
{
kx = parseInt(ss[1]) - 1;
}
}
vFocusWasSet = fnSetFocusOnInputField(fields[ix]);
fields[ix].select();
j = fields.length;
}
}
if ( event.shiftKey==false)
{
i = init;
j = 0;
while (j < fields.length)
{
ix = i%parseInt(ss[1]);
kx = ix + 1;
if ( kx >= parseInt(ss[1]) )
{
kx = 0;
}
while (( (fields[kx].id.charAt(4)  =="1") || (fields[kx].id.charAt(5) == "1") ) && ( j < fields.length ))
{
kx++;
j++;
i++;
ix = i%parseInt(ss[1]);
if ( kx >= parseInt(ss[1]) )
{
kx = 0;
}
}
if ( kx == 0 )
{
ix = parseInt(0);
}
if ( ix == 0 )
{
vFocusWasSet = false;
while ( vFocusWasSet == false )
{
vFocusWasSet = fnSetFocusOnInputField(fields[ix]);
if ( vFocusWasSet == false )
{
fields[ix].focus();
ix++;
}
}
fields[ix].focus();
}
else
{
vFocusWasSet = fnSetFocusOnInputField(fields[ix]);
}
fields[ix].select();
j = fields.length;
}
}
}
if(event.keyCode==78)
{
if(event.ctrlKey)
{
ss = field.position.split("-");
fields=document.getElementsByTagName("INPUT");
init = fnGetStartIndexForFocusSetting(event.keyCode, event.shiftKey, ss);
i = init;
j = 0;
while (j < fields.length)
{
ix = i%parseInt(ss[1]);
if(fields[ix].id!=field.id)
{
if(((fields[ix].id.charAt(3)  =="0")&(fields[ix].value.length==0)) | (fields[ix].inerror=="1"))
{
fnSetFocusOnInputField(fields[ix]);
fields[ix].select();
j = fields.length;
}
}
j++;
i++;
}
}
}
}
function fnGetStartIndexForFocusSetting(aKeyCode, aShiftKey, aSS)
{
var     vCorrection = 0;
var     vStartIndex = 0;
switch ( aKeyCode )
{
case 38:  vCorrection =  2 ;   break;
case 40:  vCorrection =  0 ;   break;
case 78:  vCorrection =  1 ;   break;
case  9:
if ( aShiftKey == false )
{
vCorrection = 1;
}
else
{
vCorrection = 1;
}
break
default:
vCorrection = 0;
}
if(aSS[0]==aSS[1])
{
vStartIndex = 0;
}
else
{
vStartIndex = parseInt(aSS[0])-vCorrection;
}
if ( vStartIndex < 0 )
{
vStartIndex = vStartIndex + parseInt(aSS[1]);
}
return  vStartIndex;
}
function fnCatchParmInput(field)
{
var num = /\d/g;
var date = /\d|\/|\.|-/g;
var alpha= /\D/g;
if (field.id.charAt(8)  =="N" ) {
if (num.exec(String.fromCharCode(event.keyCode))== null){
event.returnValue=false;
return;
}
}
if (field.id.charAt(8).toUpperCase()  == "D" )
{
if (date.exec(String.fromCharCode(event.keyCode))== null){
event.returnValue=false;
return;
}
}
if (field.id.charAt(8)  =="A" ) {
if (alpha.exec(String.fromCharCode(event.keyCode))== null){
event.returnValue=false;
return;
}
}
field.imod=true;
field.mod       = "1";
field.className = "modified";
field.id=fnSetCharAt(field.id,7,"1");
fnSetPrmToolTip();
}
function fnIsCompliantToDateFormat(aField, aRe1 , aRe2, aAddcent, aDateformat )
{
var vIsCompliantToDateFormat = true;
var vTrimmedInputValue       ;
if(aRe1.test(aField.value)==true)
{
vIsCompliantToDateFormat = true;
}
else
{
vIsCompliantToDateFormat = false;
if ( aDateformat.length == 10 )
{
if ( aAddcent == "Y" )
{
vTrimmedInputValue = aField.value;
if(aRe2.test(vTrimmedInputValue)==false)
{
vIsCompliantToDateFormat = false;
}
else
{
vIsCompliantToDateFormat = true;
aField.id = fnSetCharAt(aField.id,8,"d");
}
}
}
}
return (vIsCompliantToDateFormat);
}
function fnIsDateValid(field)
{
var vIsDateValid = true;
var pdate;
var re1;
var re2;
var vCompliesToDateFormat = false;
switch(g_dateformat)
{
case "DD.MM.YYYY":
re1=/^\d{1,2}\.\d{1,2}\.\d{4}$/g;
re2=/^\d{1,2}\.\d{1,2}\.\d{2}$/g;
vCompliesToDateFormat = fnIsCompliantToDateFormat(field, re1, re2, g_addcent, g_dateformat );
if(vCompliesToDateFormat==false)
{
fnDateFormatError1(field);
vIsDateValid = false;
}
else
{
pdate = field.value.split(".");
dd = pdate[0];
mm = pdate[1];
yy = pdate[2];
if(fnDateCheck(dd,mm,yy,field)==false)
{
vIsDateValid = false;
}
}
break;
case "DD.MM.YY":
re1=/^\d{1,2}\.\d{1,2}\.\d{2}$/g;
re2=/^\d{1,2}\.\d{1,2}\.\d{2}$/g;
vCompliesToDateFormat = fnIsCompliantToDateFormat(field, re1, re2, g_addcent, g_dateformat );
if(vCompliesToDateFormat==false)
{
fnDateFormatError1(field);
vIsDateValid = false;
}
else
{
pdate = field.value.split(".");
dd = pdate[0];
mm = pdate[1];
yy = pdate[2];
if(fnDateCheck(dd,mm,yy,field)==false)
{
vIsDateValid = false;
}
}
break;
case "MM/DD/YYYY":
re1=/^\d{1,2}\/\d{1,2}\/\d{4}/g;
re2=/^\d{1,2}\/\d{1,2}\/\d{2}$/g;
vCompliesToDateFormat = fnIsCompliantToDateFormat(field, re1, re2, g_addcent, g_dateformat );
if(vCompliesToDateFormat==false)
{
fnDateFormatError1(field);
vIsDateValid = false;
}
else
{
pdate = field.value.split("/");
dd = pdate[1];
mm = pdate[0];
yy = pdate[2];
if(fnDateCheck(dd,mm,yy,field)==false)
{
vIsDateValid = false;
}
}
break;
case "DD/MM/YYYY":
re1=/^\d{1,2}\/\d{1,2}\/\d{4}$/g;
re2=/^\d{1,2}\/\d{1,2}\/\d{2}$/g;
vCompliesToDateFormat = fnIsCompliantToDateFormat(field, re1, re2, g_addcent, g_dateformat );
if(vCompliesToDateFormat==false)
{
vIsDateValid = false;
fnDateFormatError1(field);
}
else
{
pdate = field.value.split("/");
dd = pdate[0];
mm = pdate[1];
yy = pdate[2];
if(fnDateCheck(dd,mm,yy,field)==false)
{
vIsDateValid = false;
}
}
break;
case "DD-MM-YYYY":
re1=/^\d{1,2}-\d{1,2}-\d{4}$/g;
re2=/^\d{1,2}-\d{1,2}-\d{2}$/g;
vCompliesToDateFormat = fnIsCompliantToDateFormat(field, re1, re2, g_addcent, g_dateformat );
if(vCompliesToDateFormat==false)
{
fnDateFormatError1(field);
vIsDateValid = false;
}
else
{
pdate = field.value.split("-");
dd = pdate[0];
mm = pdate[1];
yy = pdate[2];
if(fnDateCheck(dd,mm,yy,field)==false)
{
vIsDateValid = false;
}
}
break;
case "DD-MM-YY":
re1=/^\d{1,2}-\d{1,2}-\d{2}$/g;
re2=/^\d{1,2}-\d{1,2}-\d{2}$/g;
vCompliesToDateFormat = fnIsCompliantToDateFormat(field, re1, re2, g_addcent, g_dateformat );
if(vCompliesToDateFormat==false)
{
fnDateFormatError1(field);
vIsDateValid = false;
}
else
{
pdate = field.value.split("-");
dd = pdate[0];
mm = pdate[1];
yy = pdate[2];
if(fnDateCheck(dd,mm,yy,field)==false)
{
vIsDateValid = false;
}
}
break;
case "MM/DD/YY":
re1=/^\d{1,2}\/\d{1,2}\/\d{2}$/g;
re2=/^\d{1,2}\/\d{1,2}\/\d{2}$/g;
vCompliesToDateFormat = fnIsCompliantToDateFormat(field, re1, re2, g_addcent, g_dateformat );
if(vCompliesToDateFormat==false)
{
fnDateFormatError1(field);
vIsDateValid = false;
}
else
{
pdate = field.value.split("/");
dd = pdate[1];
mm = pdate[0];
yy = pdate[2];
if(fnDateCheck(dd,mm,yy,field)==false)
{
vIsDateValid = false;
}
}
break;
default:
vIsDateValid = true;
}
return(vIsDateValid);
}
function fnDateCheck(dd,mm,yy,field) {
parms = new Array;
var msg;
var ldd;
dd=parseInt(dd,10);
mm=parseInt(mm,10);
yy=parseInt(yy,10);
if((mm<1)||(mm>12)) {
parms[0]=mm.toString();
fnPrmShowMsg(fnFormatMsg("DOC8055E",parms));
fnSetFocusOnInputField(field);
field.select();
return(false);
}
switch(mm) {
case 1:
ldd=31
break;
case 2:
if(fnIsLeapYear(yy)) {
ldd=29;
} else {
ldd=28;
}
break;
case 3:
ldd=31;
break;
case 4:
ldd=30;
break;
case 5:
ldd=31;
break;
case 6:
ldd=30;
break;
case 7:
ldd=31;
break;
case 8:
ldd=31;
break;
case 9:
ldd=30;
break;
case 10:
ldd=31;
break;
case 11:
ldd=30;
break;
case 12:
ldd=31
break;
}
if((dd<1)||dd>ldd) {
parms[0]=mm.toString();
parms[1]=ldd.toString();
fnPrmShowMsg(fnFormatMsg("DOC8054E",parms));
fnSetFocusOnInputField(field);
field.select();
return(false);
}
return(true);
}
function fnIsLeapYear(year) {
if(year.length==2) {
year=year+2000;
}
return (year%4==0)&&((year%100!=0)||(year%400==0));
}
function fnDateFormatError1(field) {
var parms = new Array();
parms[0] =g_dateformat;
fnPrmShowMsg(fnFormatMsg("DOC8052E",parms));
fnSetFocusOnInputField(field);
field.select();
}
function fnSaveParm()
{
var i;
setMsgLanguage(g_languageid);
fields= document.all.tags("input").length;
field  = document.all.tags("input");
for (i=0;i<fields;i++) {
if(field[i].mod =="1") {
if(field[i].length==0) {
field.value="NULL";
}
fnSave4PostRequest(field[i].name+"-setvalue="+field[i].value);
if(field[i].inerror=="1")
{
fnCommandListAdd("seterror",field[i].name)
} else {
fnCommandListAdd("unseterror",field[i].name)
}
}
}
}
function fnHasMinLength(field)
{
if(field.value.length < parseInt(field.minlength)) {
var parms = new Array();
parms[0] =field.minlength;
parms[1] =field.maxLength;
parms[2] =field.value.length;
fnPrmShowMsg(fnFormatMsg("DOC8053E",parms));
fnSetFocusOnInputField(field);
field.select();
return false;
}
return true;
}
function fnParmProperties()
{
var obj_id = parent.fnGetGlobalVariable("gObjIdToPassToPopup");
if (obj_id=="" || obj_id==null )
{
obj_id = "prp";
}
obj = parent.document.getElementById(obj_id);
while(obj.tagName!="TR") {
obj=obj.parentElement;
if(obj==null) {
return false;
}
}
for(i=0;i<obj.all.length;i++) {
if(obj.all[i].nodeName=="INPUT")
{
field=obj.all[i];
gTopObj.main.fnSave4PostRequest(field.name+"-setvalue="+field.value);
fnShowProperties(field.name, null, null);
return;
}
}
if (obj.GILName != "")
{
fnShowProperties(obj.GILName, obj.version, null);
}
}
function fnPrmSeek(aSeekString)
{
var vSeekString = aSeekString;
var vParms      = new Array();
var  obj = null;
var obj_id = parent.fnGetGlobalVariable("gObjIdToPassToPopup");
var i = 0;
var vSeekStringFound = false;
vParms[0] = aSeekString;
if (obj_id=="" || obj_id==null )
{
}
else
{
obj = parent.document.getElementById(obj_id);
while(obj.tagName!="BODY")
{
obj=obj.parentElement;
if(obj==null)
{
return false;
}
}
for(i=0;i<obj.all.length;i++)
{
if(obj.all[i].nodeName=="INPUT")
{
field=obj.all[i];
if ( field.value.indexOf(vSeekString) >= 0 )
{
vSeekStringFound     = true;
field.className  ="found";
}
}
}
}
if ( vSeekStringFound == false )
{
parent.fnPrmShowMsg(fnFormatMsg("DOC8070I", vParms));
}
}
function fnPrmCopyToClipboard()
{
var vDebug = false;
var vContextObj = parent.fnGetGlobalVariable("gContextObj");
var vElement = parent.document.getElementById(vContextObj);
if ( vDebug == true )
{
alert("fnPrmCopyToClipboard   global variable gContextObj  = " +   vContextObj );
}
if ( vElement != null )
{
vElement.select();
vElement.focus();
parent.document.execCommand('Copy');
window.status = "Copy to Clipboard";
}
else
{
alert("fnPrmCopyToClipboard() vElement for id=" +  vContextObj   + " was null");
}
}
function fnPrmPasteFromClipboard()
{
var vDebug = false;
var vContextObj = parent.fnGetGlobalVariable("gContextObj");
var vElement = parent.document.getElementById(vContextObj);
if ( vDebug == true )
{
alert("fnPrmPasteFromClipboard    global variable gContextObj = " +   vContextObj );
}
if ( vElement != null )
{
vElement.focus();
parent.document.execCommand("Paste");
window.status = "Paste from Clipboard";
}
else
{
alert("fnPrmPasteFromClipboard() vElement for id=" + vContextObj + " was null");
}
}
function fnUnprotect(aMode)
{
var obj_id = parent.fnGetGlobalVariable("gContextObj");
var vGoUpToTagname = null;
var vField = null;
var vObjLength = 0;
var i = 0;
var j = 0;
var vParentElement;
if ( aMode == "currentprotected" )
{
vGoUpToTagname = "TR";
}
else
{
vGoUpToTagname = "TABLE";
}
if(obj_id=="") {
return false;
}
obj = parent.document.getElementById(obj_id);
while(obj.tagName!= vGoUpToTagname)
{
obj=obj.parentElement;
if(obj==null)
{
return false;
}
}
vObjLength = obj.all.length;
for(i=0;i<vObjLength;i++)
{
if(obj.all[i].nodeName=="INPUT")
{
vField=obj.all[i];
if(vField.id.charAt(5)=="1")
{
vField.readOnly=false;
vField.id=fnSetCharAt(vField.id,5,"0");
vParentElement = obj.all[i].parentElement.parentElement;
for(j=0;j<vParentElement.all.length;j++)
{
if(vParentElement.all[j].nodeName=="IMG")
{
vParentElement.all[j].style.visibility="hidden";
}
}
}
}
}
if ( aMode == "currentprotected" )
{
gactions.unprotected =  false;
}
else
{
gactions.unprotectedall = false;
}
}
function fnInputInError(field)
{
event.cancelBubble = true;
event.returnValue  = false;
event.keyCode      = 0;
field.inerror="1";
field.style.color="red";
return true;
}
function fnInputInErrorOff(field)
{
field.inerror="0";
field.style.color="";
return true;
}
function fnParmShowHelp(GILname)
{
var vHelpId;
vHelpId = "&number=" + GILname;
parent.fnSave4PostRequest(vHelpId);
parent.fnPostAsyncSvrRequest("gethelp");
return true;
}
function fnIsMaskValid(field)
{
var i = 0;
var k = 0;
var vChar;
var vRegExpStr  = null;
var re          = null;
var vRegExpTest = null;
var vZFirstPos  = 0;
var vZCount = 0;
var slen;
var start;
var savei;
var vTestAgainstRegExps;
var parms = new Array;
var vDebug = false;
field.value=field.value.replace(/\s/g,"");
fieldValue = field.value;
s    = field.mask;
slen = s.length;
if ( vDebug == true )
{
alert("*00* field.mask = s = " + s + " slen=" + slen);
}
for ( i=0 ; i<slen; i++)
{
vChar =  s.charAt(i);
if ( vChar == "Z" )
{
vZCount++;
}
}
vZCount++;
vRegExpStr  = new Array(vZCount);
re          = new Array(vZCount);
vRegExpTest = new Array(vZCount);
if ( vDebug == true )
{
alert("*01* vZCount =  " + vZCount);
}
if ( vZCount == 1 )
{
vRegExpStr[0] = s;
k = vZCount;
}
else
{
vZFirstPos = s.indexOf("Z");
vZLastPos  = s.lastIndexOf("Z");
start = s.substring(0,vZFirstPos);
k = 0;
for ( i=vZFirstPos; i <= vZLastPos; i++)
{
vChar = s.charAt(i);
if ( vChar == "Z" )
{
vRegExpStr[k] = start.concat(s.substring(i,slen));
k++;
}
if (( vChar == "." ) || ( vChar == "," ))
{
vRegExpStr[k] = start.concat(s.substring(i,slen));
k++;
}
}
if ( vDebug == true )
{
alert("*2b* k = " + k + "savei="+savei);
}
for  ( i=vZLastPos; i < slen; i++)
{
vChar = s.charAt(i);
if (( vChar == "." ) || ( vChar == "," ))
{
vRegExpStr[k] = start.concat(s.substring(i,slen));
k++;
}
if ( vChar == "N" )
{
vRegExpStr[k] = start.concat(s.substring(i,slen));
k++;
i = s.length;
}
}
}
vTestAgainstRegExps = false;
i = 0;
while ( ( i < k )  && ( vTestAgainstRegExps == false ) )
{
vRegExpStr[i] = vRegExpStr[i].replace(/\,/g,"(\\,{1})");
vRegExpStr[i] = vRegExpStr[i].replace(/\./g,"(\\.{1})");
vRegExpStr[i] = vRegExpStr[i].replace(/S/g,"([-|\\+]{0,1})");
vRegExpStr[i] = vRegExpStr[i].replace(/Z/g,"\([0-9]{1})");
vRegExpStr[i] = vRegExpStr[i].replace(/N/g,"\([0-9]{1})");
vRegExpStr[i] ="^"+vRegExpStr[i]+"$";
re[i] = new RegExp(vRegExpStr[i]);
vRegExpTest[i] = re[i].test(fieldValue);
if ( vDebug == true )
{
alert("***** vRegExpTest[" + i + "]=" + vRegExpTest[i] + " vRegExpStr[" + i + "] = " + vRegExpStr[i]);
}
if ( vRegExpTest[i] == true )
{
vTestAgainstRegExps = true;
}
else
{
i++;
}
}
if( vTestAgainstRegExps == false)
{
parms[0]=field.mask;
fnSetFocusOnInputField(field);
field.select();
fnPrmShowMsg(fnFormatMsg("DOC8056E",parms));
return(false);
}
else
{
return(true);
}
}
function fnPrmShowMsg(msg) {
var vResponse = processOKDialog("",msg, "docerror.gif", false, false);
}
function fnResetPVPArgFieldInError(aField, aCountPVPInError, aCountPVPInErrorMod)
{
var vInerror;
if ( aCountPVPInError > 0 )
{
if ( aCountPVPInErrorMod > 0 )
{
vInerror = "0";
}
else
{
vInerror = "1";
}
}
else
{
vInerror = aField.inerror;
}
return vInerror;
}
function fnIsFieldModified(aField)
{
var vIsFieldModified = true;
if ( ( typeof aField.imod ) == "undefined" )
{
vIsFieldModified = false;
}
else
{
if ( aField.imod == true )
{
vIsFieldModified = false;
}
else
{
vIsFieldModified = true;
}
}
return (vIsFieldModified);
}
function fnIsAlphaBlankOrSpecialCharacter(aChar)
{
var  vIsAlphaBlankOrSpecialCharacter = false;
if (   ( aChar == 32 )                        ||
( aChar == 160 )                       ||
( ( aChar >= 65 ) && ( aChar <= 90 ))  ||
( ( aChar >= 97 ) && ( aChar <= 122))  ||
( ( aChar >= 192) && ( aChar <= 214))  ||
( ( aChar >= 216) && ( aChar <= 221))  ||
( ( aChar >= 223) && ( aChar <= 246))  ||
( ( aChar >= 248) && ( aChar <= 255)) )
{
vIsAlphaBlankOrSpecialCharacter = true;
}
return       vIsAlphaBlankOrSpecialCharacter;
}
function fnIsAlphaBlankOrSpecialCharacterString(aString)
{
var  vIsAlphaBlankOrSpecialCharacterString = true;
var  vChar = null;
var  vIsABSCharacter = true;
var  i = 0;
var  vDebug = false;
if  ( aString.length != 0 )
{
while (( i < aString.length ) && ( vIsABSCharacter == true ))
{
vChar = aString.charCodeAt(i);
vIsABSCharacter = fnIsAlphaBlankOrSpecialCharacter(vChar);
if ( vDebug == true )
{
alert("i=" + i + " vChar=" + vChar + " vIsABSCharacter=" +  vIsABSCharacter );
}
i++;
}
if ( vIsABSCharacter == true )
{
vIsAlphaBlankOrSpecialCharacterString = true;
}
else
{
vIsAlphaBlankOrSpecialCharacterString = false;
}
}
return       vIsAlphaBlankOrSpecialCharacterString;
}
function fnRemoveLeadingZeroFromMonthOrDay( aMonthOrDay , aDatzer )
{
var vMonthOrDay = null;
if ( aDatzer == "1" )
{
vMonthOrDay = fnRemoveLeadingDateZero(aMonthOrDay);
}
else
{
vMonthOrDay =  aMonthOrDay
}
return vMonthOrDay;
}
