
/*\// -------------------------------------------------------------- */
/*\// Licensed Material - Property of IBM                            */
/*\//                                                                */
/*\// 5655-002                                                       */
/*\//                                                                */
/*\// (C) Copyright IBM Corp. 2003   All Rights Reserved             */
/*\//                                                                */
/*\// US Government Users Restricted Rights - Use, duplication or    */
/*\// disclosure restricted by GSA ASP Schedule Contract with        */
/*\// IBM Corp.                                                      */
/*\// -------------------------------------------------------------- */
function setMsgLanguage(language)
{
language = language.toLowerCase();
switch(language)
{
case 'de':
DOC8050E  = "Wert ung\u00fcltig! Nur numerische Werte zul\u00e4ssig.";
DOC8051E  = "Eingabe erforderlich.";
DOC8052E  = "Das Datumsformat ist nicht zul\u00e4ssig. Das richtige Format ist: %0 .";
DOC8053E  = "Der Wert muss zwischen %0 und %1 Zeichen lang sein; L\u00e4nge %2 nicht zul\u00e4ssig.";
DOC8054E  = "Die Tage im Monat %0 m\u00fcssen zwischen 1 und %1 liegen.";
DOC8055E  = "Der Monat %0 ist nicht zul\u00e4ssig. Der Monat muss zwischen 1 und 12 liegen.";
DOC8056E  = "Format: %0 .";
DOC8057E  = "Email Adresse syntaktisch ung\u00fcltig.";
DOC8058E  = "Email Adressenliste muss aus g\u00fcltigen Email Adressen bestehen, die durch ein Komma getrennt sind.";
DOC8059E  = "Reserviert.";
DOC8060I  = "Rechtschreibpr\u00fcfung abgeschlossen.";
DOC8061I  = "Keine falsch geschriebenen W\u00f6rter gefunden.";
DOC8062I  = "%0 Eintr\u00e4ge gefunden. Maximale Anzahl anzeigbarer Eintr\u00e4ge ist auf %1 gesetzt.";
DOC8063E  = "Ein erforderliches PDP-Argumentfeld ist leer.";
DOC8064E  = "Alle erforderlichen PDP-Argumentfelder sind leer.";
DOC8065E  = "PDP-Argumentfeld ist fehlerhaft.";
DOC8066E  = "PVP-Argumentfeld ist fehlerhaft.";
DOC8067E  = "Der Selektionsname muss mit einem Prefix aus der Prefix-Liste starten.";
DOC8068E  = "Wert ist nicht alphanumerisch.";
DOC8069E  = "Wert ung\u00fcltig! Nur Alphabetische Zeichen zul\u00e4ssig.";
DOC8070I  = "Zeichenkette %0 nicht gefunden.";
DOC8071I  = "Reserviert.";
DOC8072I  = "Reserviert.";
DOC8073E  = "Auf Methoden von Klassen, die in docclient.jar definiert sind, konnte nicht zugegriffen werden.";
DOC8074E  = "Auf Funktionen, die in doccustomer.js definiert sind, konnte nicht zugegriffen werden.";
DOC8075E  = "Reserviert.";
DOC8076E  = "Reserviert.";
DOC8077E  = "Reserviert.";
DOC8078E  = "Reserviert.";
break;
case 'fr':
DOC8050E  = "Valeur incorrecte !  Seules les valeurs num\u00e9riques sont possibles.";
DOC8051E  = "Saisie requise.";
DOC8052E  = "Format de date non autoris\u00e9. Le format correct est %0 .";
DOC8053E  = "Cette valeur devrait comprendre entre %0 et %1 caract\u00e8res, et non %2 .";
DOC8054E  = "Les jours du mois %0 devraient \u00eatre compris entre 1 et %1 .";
DOC8055E  = "Mois %0 non autoris\u00e9. Le mois doit \u00eatre compris entre 1 et 12.";
DOC8056E  = "Format is: %0 .";
DOC8057E  = "Email address is syntactically invalid";
DOC8058E  = "Email address list must consist of valid email addresses separated by a comma.";
DOC8059E  = "R\u00e9serv\u00e9 pour une utilisation future.";
DOC8060I  = "Spell check finished.";
DOC8061I  = "No misspelt words found.";
DOC8062I  = "%0 item(s) found. Maximum number of items displayed set to %1 .";
DOC8063E  = "A mandatory PDP argument field is empty.";
DOC8064E  = "All mandatory PDP argument fields are empty.";
DOC8065E  = "PDP argument field is in error.";
DOC8066E  = "PVP argument field is in error.";
DOC8067E  = "The selection name must start with a prefix defined in the prefix list.";
DOC8068E  = "Value is not alphanumeric.";
DOC8069E  = "R\u00e9serv\u00e9 pour une utilisation future.";
DOC8070I  = "String %0 not found.";
DOC8071I  = "R\u00e9serv\u00e9 pour une utilisation future.";
DOC8072I  = "R\u00e9serv\u00e9 pour une utilisation future.";
DOC8073E  = "Unable to access methods of classes defined in docclient.jar.";
DOC8074E  = "Unable to access functions defined in doccustomer.js.";
DOC8075E  = "R\u00e9serv\u00e9 pour une utilisation future.";
DOC8076E  = "R\u00e9serv\u00e9 pour une utilisation future.";
DOC8077E  = "R\u00e9serv\u00e9 pour une utilisation future.";
DOC8078E  = "R\u00e9serv\u00e9 pour une utilisation future.";
break;
case 'es':
DOC8050E  = "El valor no es v\u00e1lido. S\u00f3lo se permiten valores num\u00e9ricos.";
DOC8051E  = "Es necesario realizar una entrada.";
DOC8052E  = "El formato de fecha no es correcto. El formato correcto es %0.";
DOC8053E  = "El valor debe tener de %0 a %1 caracteres, no %2.";
DOC8054E  = "Los d\u00edas del mes %0 deben estar entre 1 y %1.";
DOC8055E  = "El mes %0 no est\u00e1 permitido. El mes debe ser un valor entre 1 y 12.";
DOC8056E  = "Format is: %0.";
DOC8057E  = "Email address is syntactically invalid.";
DOC8058E  = "Email address list must consist of valid email addresses separated by a comma.";
DOC8059E  = "Reservado para uso futuro.";
DOC8060I  = "Spell check finished.";
DOC8061I  = "No misspelt words found.";
DOC8062I  = "%0 item(s) found. Maximum number of items displayed set to %1.";
DOC8063E  = "A mandatory PDP argument field is empty.";
DOC8064E  = "All mandatory PDP argument fields are empty.";
DOC8065E  = "PDP argument field is in error.";
DOC8066E  = "PVP argument field is in error.";
DOC8067E  = "The selection name must start with a prefix defined in the prefix list.";
DOC8068E  = "Value is not alphanumeric.";
DOC8069E  = "Value invalid! Only alphabetic characters possible.";
DOC8070I  = "String %0 not found.";
DOC8071I  = "Reservado para uso futuro.";
DOC8072I  = "Reservado para uso futuro.";
DOC8073E  = "Unable to access methods of classes defined in docclient.jar.";
DOC8074E  = "Unable to access functions defined in doccustomer.js.";
DOC8075E  = "Reservado para uso futuro.";
DOC8076E  = "Reservado para uso futuro.";
DOC8077E  = "Reservado para uso futuro.";
DOC8078E  = "Reservado para uso futuro.";
break;
case 'da':
DOC8050E  = "Ugyldig v\u00e6rdi. Du kan kun skrive tal.";
DOC8051E  = "Input n\u00f8dvendigt.";
DOC8052E  = "Datoformatet er ikke tilladt. Det korrekte format er %0 .";
DOC8053E  = "V\u00e6rdier skal have fra %0 til %1 tegn, ikke %2 .";
DOC8054E  = "Dage i m\u00e5neden %0 skal ligge mellem 1 og %1 .";
DOC8055E  = "M\u00e5neden %0 er ikke tilladt. M\u00e5neden skal ligge mellem 1 og 12.";
DOC8056E  = "Formatet er: %0 .";
DOC8057E  = "Email-adressen er syntaktisk forkert.";
DOC8058E  = "Email-adresselisten skal best\u00e5 af valide email-adresser adskilt med komma.";
DOC8059E  = "Reserveret til fremtidig brug";
DOC8060I  = "Stavekontrol udf\u00f8rt.";
DOC8061I  = "Ingen stavefejl fundet.";
DOC8062I  = "%0 emne(r) fundet. Maximum antal viste emner er sat til %1 .";
DOC8063E  = "Fejlagtigt felt til PDP.";
DOC8064E  = "Alle p\u00e5kr\u00e6vede felter til PDP er tomme.";
DOC8065E  = "Fejlagtigt felt til PDP.";
DOC8066E  = "Fejlagtigt felt til PVP.";
DOC8067E  = "S\u00f8genavnet skal starte med et prefix, som er defineret i prefix-listen.";
DOC8068E  = "V\u00e6rdien er ikke alfanumerisk.";
DOC8069E  = "V\u00e6rdien er forkert! Kun alfabetiske karakterer kan anvendes.";
DOC8070I  = "String %0 not found.";
DOC8071I  = "Reserveret til fremtidig brug.";
DOC8072I  = "Reserveret til fremtidig brug.";
DOC8073E  = "Kan ikke anvende metoder defineret i docclient.jar.";
DOC8074E  = "Kan ikke anvende funktioner defineret i doccustomer.js.";
DOC8075E  = "Reserveret til fremtidig brug.";
DOC8076E  = "Reserveret til fremtidig brug.";
DOC8077E  = "Reserveret til fremtidig brug.";
DOC8078E  = "Reserveret til fremtidig brug.";
break;
case 'nl' :
DOC8050E  = "Ongeldige waarde!  Alleen numerieke waarden toegestaan.";
DOC8051E  = "Invoer vereist.";
DOC8052E  = "Datumnotatie niet toegestaan. De juiste notatie is %0 .";
DOC8053E  = "De waarde moet uit %0 tot %1 tekens bestaan, niet uit %2 .";
DOC8054E  = "Dagen in maand %0 moeten tussen 1 en %1 zijn.";
DOC8055E  = "Maand %0 is niet toegestaan. Geef voor de maand een getal op tussen 1 en 12.";
DOC8056E  = "Format is: %0 .";
DOC8057E  = "Email address is syntactically invalid.";
DOC8058E  = "Email address list must consist of valid email addresses separated by a comma.";
DOC8059E  = "Gereserveerd voor toekomstig gebruik.";
DOC8060I  = "Spell check finished.";
DOC8061I  = "No misspelt words found.";
DOC8062I  = "%0 item(s) found. Maximum number of items displayed set to %1 .";
DOC8063E  = "A mandatory PDP argument field is empty.";
DOC8064E  = "All mandatory PDP argument fields are empty.";
DOC8065E  = "PDP argument field is in error.";
DOC8066E  = "PVP argument field is in error.";
DOC8067E  = "The selection name must start with a prefix defined in the prefix list.";
DOC8068E  = "Value is not alphanumeric.";
DOC8069E  = "Gereserveerd voor toekomstig gebruik.";
DOC8070I  = "String %0 not found.";
DOC8071I  = "Gereserveerd voor toekomstig gebruik.";
DOC8072I  = "Gereserveerd voor toekomstig gebruik.";
DOC8073E  = "Unable to access methods of classes defined in docclient.jar.";
DOC8074E  = "Unable to access functions defined in doccustomer.js.";
DOC8075E  = "Gereserveerd voor toekomstig gebruik.";
DOC8076E  = "Gereserveerd voor toekomstig gebruik.";
DOC8077E  = "Gereserveerd voor toekomstig gebruik.";
DOC8078E  = "Gereserveerd voor toekomstig gebruik.";
break;
default:
if (language != 'en')
{
alert('Invalid language parameter! US English will be used instead.');
language = 'en';
}
DOC8050E  = "Value invalid!  Only numeric values possible.";
DOC8051E  = "Input required.";
DOC8052E  = "Format of date is not allowed. Correct format is %0 .";
DOC8053E  = "Value should have %0 to %1 characters, not %2 .";
DOC8054E  = "Days in month %0 must be between 1 and %1 .";
DOC8055E  = "Month %0 is not allowed. Month must be between 1 a 12.";
DOC8056E  = "Format is: %0 .";
DOC8057E  = "Email address is syntactically invalid.";
DOC8058E  = "Email address list must consist of valid email addresses separated by a comma.";
DOC8059E  = "Reserved for future use.";
DOC8060I  = "Spell check finished.";
DOC8061I  = "No misspelt words found.";
DOC8062I  = "%0 item(s) found. Maximum number of items displayed set to %1 .";
DOC8063E  = "A mandatory PDP argument field is empty.";
DOC8064E  = "All mandatory PDP argument fields are empty.";
DOC8065E  = "PDP argument field is in error.";
DOC8066E  = "PVP argument field is in error.";
DOC8067E  = "The selection name must start with a prefix defined in the prefix list.";
DOC8068E  = "Value is not alphanumeric.";
DOC8069E  = "Value invalid! Only alphabetic characters possible.";
DOC8070I  = "String %0 not found.";
DOC8071I  = "Reserved for future use.";
DOC8072I  = "Reserved for future use.";
DOC8073E  = "Unable to access methods of classes defined in docclient.jar.";
DOC8074E  = "Unable to access functions defined in doccustomer.js.";
DOC8075E  = "Reserved for future use.";
DOC8076E  = "Reserved for future use.";
DOC8077E  = "Reserved for future use.";
DOC8078E  = "Reserved for future use.";
break;
}
return language;
}
