
/*\// -------------------------------------------------------------- */
/*\// Licensed Material - Property of IBM                            */
/*\//                                                                */
/*\// 5655-002                                                       */
/*\//                                                                */
/*\// (C) Copyright IBM Corp. 2003   All Rights Reserved             */
/*\//                                                                */
/*\// US Government Users Restricted Rights - Use, duplication or    */
/*\// disclosure restricted by GSA ASP Schedule Contract with        */
/*\// IBM Corp.                                                      */
/*\// -------------------------------------------------------------- */
function fnOrganizePropertiesWindow(parNameLength, parValueLength, parLineNumber, parGroupCount)
{
var vOKButtonHeight;
var vFixLines;
var vRowInfo;
var vWindowHeight;
var vWindowWidth;
var vTmpObj;
vTmpObj         = document.getElementById("pb-1");
vOKButtonHeight = vTmpObj.offsetHeight + 1;
vRowInfo     = adaptColumnWidth();
vWindowWidth = vRowInfo.mRowLen + 8;
parGroupCount = (parGroupCount * 1.7);
vWindowHeight = (vRowInfo.mRowHeight + 10) * (parLineNumber + parGroupCount) + vOKButtonHeight;
if (vWindowHeight > window.screen.height-100)
{
vWindowHeight = window.screen.height-100;
}
if (vWindowWidth > window.screen.width)
vWindowWidth = window.screen.width;
fnCalculateTopLeftCorner(vWindowWidth);
window.resizeTo(vWindowWidth, vWindowHeight);
}
function fnKeyEvent()
{
if (event.keyCode == "27")
{
window.close();
}
}
		
function fnOnUnloadLocal()
{
var vSearchResultTransData;
if (typeof(self.opener.g_PropertiesWindow) != "undefined")
{
self.opener.g_PropertiesWindow        = null;
self.opener.parent.g_PropertiesWindow = null;
}
vSearchResultTransData = self.opener.g_SearchResultTransData;
if (vSearchResultTransData == null)
{
if (self.opener && !self.opener.closed)
{
vSearchResultTransData = self.opener.parent.g_SearchResultTransData;
}
}
if (vSearchResultTransData != null)
{
if (vSearchResultTransData.dlgopen)
{
self.opener.unloadfunction();
}
}
fnSetParamFocus();
}
function fnSetParamFocus()
{
var vElement = null;
var vElementId = null;
if (self.opener &&  self.opener.g_whatAmI  == "param" )
{
vElementId =  self.opener.fnGetGlobalVariable("gContextObj");
if ( vElementId != null )
{
vElement =  self.opener.document.getElementById(vElementId);
if ( vElement != null )
{
if (( vElement.id.charAt(4)=="0") && ( vElement.id.charAt(5)=="0" ))
{
vElement.focus();
}
}
}
}
}
function fnOnloadLocal()
{
var vOKButton;
var vHelpButton;
if (typeof(self.opener.g_PropertiesWindow) != "undefined")
{
	  self.opener.g_PropertiesWindow        = self;
	  self.opener.parent.g_PropertiesWindow = self;
	}
	g_actualButton = 1-0;  			
	var vBut =  document.getElementById("pb-"+g_actualButton);
g_actualButton++;
event.keyCode = 9;
fnIgnoreEvent();
	vBut.focus();
fnCheckForBulletList();
vOKButton   = document.getElementById("pb-1");
vHelpButton = document.getElementById("pb-2");
if (typeof(self.opener.g_sdbNlsObj) != "undefined")
{
vOKButton.innerHTML   = self.opener.g_sdbNlsObj.ButtonOk;
vHelpButton.innerHTML = self.opener.g_sdbNlsObj.ButtonHelp;
}
eval("document.onmouseover=fnMouseOverEventHandler");
eval("document.onmouseout=fnMouseOutEventHandler");
focus();
}
function fnCheckForBulletList()
{
var vBullListObj;
var cBullListObj = document.getElementsByName("bulletlist");
var vFirstRightListEl;
var vSecRightListEl;
var vSecLeftListEl;
for ( var j=1; j<=cBullListObj.length; j++)
{
vBullListObj = cBullListObj[j-1];
if (vBullListObj != null)
{
vPosId = vBullListObj.name.substring(3);
vFirstRightListEl = document.getElementById("rt-" + vPosId);
vFirstRightListEl.innerHTML = "&#8226;"+ " " +vFirstRightListEl.innerText;
for ( var n=1; n<=2; n++)
{
vPosIdArr = vPosId.split("-");
vPosIdArr[vPosIdArr.length-1] = vPosIdArr[vPosIdArr.length-1]-0+1;
vPosId = vPosIdArr[0];
for (var i=1; i<vPosIdArr.length; i++)
{
vPosId = vPosId + "-" + vPosIdArr[i];
}
vSecLeftListEl = document.getElementById("lt-" + vPosId);
if (vSecLeftListEl != null)
{
if(vSecLeftListEl.innerText == "")
{
vSecRightListEl = document.getElementById("rt-" + vPosId);
if (vSecRightListEl != null)
{
vSecRightListEl.innerHTML = "&#8226;" + " " +vSecRightListEl.innerHTML;
}
}
}
}
}
}
}
					
function fnIgnoreEvent()
{
switch ( event.keyCode )
{
case 27:
window.close();
break;
case 13:
switch( g_actualButton)
{
case 1:
window.close();
break;
case 2:
self.opener.showhelp();
break;
default:
break;
};
break;
case 37:
case 38:
case 39:
case 40:
switch (g_actualButton)
{
case 1:
g_actualButton++;
break;
case 2:
g_actualButton--;
break;
default:
break;
};
var vBut =  document.getElementById("pb-"+g_actualButton);
vBut.focus();
break;
case 116:
	          event.keyCode = 0;
	          event.returnValue = false;
	          event.cancelBubble = true;
	
	          break;
default:
event.cancelBubble = true;
	     event.returnValue  = false;
	
	     return(false);
break;
}
}
function fnHandleClickEvent(parHelpIdStrg)
{
if (typeof(self.opener.g_PropertiesFieldHelpId) != "undefined")
{
self.opener.g_PropertiesFieldHelpId = parHelpIdStrg;
self.opener.showhelp();
}
self.focus();
if (self.opener.g_GeneralHelpWindow != null)
{
if (!self.opener.g_GeneralHelpWindow.closed)
{
self.opener.g_GeneralHelpWindow.focus();
}
}
}
function adaptColumnWidth()
{
var vTmpObj;
var vTDId;
var vColIndex;
var vArrayTD;
var vNameLen;
var vValueLen;
var vRowInfo;
vRowInfo = new Object();
vTmpObj             = document.getElementById("ft-0");
vRowInfo.mRowLen    = vTmpObj.clientWidth;
vRowInfo.mRowHeight = 0;
vNameLen            = 0;
vValueLen           = 0;
vArrayTD = document.all.tags("td");
for (vColIndex = 0; vColIndex < vArrayTD.length; vColIndex++)
{
vTDId = vArrayTD[vColIndex].id;
switch (vTDId.substring(0, 3))
{
case "lt-":
vTmpObj = document.getElementById(vTDId);
if ((vTmpObj.clientWidth + 10) > vNameLen)
{
vNameLen = vTmpObj.clientWidth + 10;
}
if (vRowInfo.mRowHeight == 0 &&
vTmpObj.clientHeight > vRowInfo.mRowHeight)
{
vRowInfo.mRowHeight = vTmpObj.clientHeight;
}
break;
case "rt-":
vTmpObj = document.getElementById(vTDId);
if ((vTmpObj.clientWidth + 46) > vValueLen)
{
vValueLen = vTmpObj.clientWidth + 46;
}
vTmpObj = document.getElementById(vTDId);
break;
default:
break;
}
}
for (vColIndex = 0; vColIndex < vArrayTD.length; vColIndex++)
{
vTDId = vArrayTD[vColIndex].id;
switch (vTDId.substring(0, 3))
{
case "lt-":
vTmpObj = document.getElementById(vTDId);
vTmpObj.style.width = vNameLen;
break;
case "rt-":
vTmpObj = document.getElementById(vTDId);
vTmpObj.style.width = vValueLen;
break;
default:
break;
}
}
vRowInfo.mRowLen = vRowInfo.mRowLen + vNameLen + vValueLen + 85;
return(vRowInfo);
}
function fnMouseOverEventHandler()
{
var vSrcElement;
vSrcElement = window.event.srcElement;
switch (vSrcElement.name)
{
case "title":
vSrcElement.className = "fontItalicBlue";
break;
case "comment":
vSrcElement.className = "fontBlue";
break;
case "entry":
vSrcElement.className = "fontBoldBlue";
break;
case "value":
vSrcElement.className = "fontBlue";
break;
default:
break;
}
}
function fnMouseOutEventHandler()
{
var vSrcElement;
vSrcElement = window.event.srcElement;
switch (vSrcElement.name)
{
case "title":
vSrcElement.className = "fontItalicBlack";
break;
case "comment":
vSrcElement.className = "fontBlack";
break;
case "entry":
vSrcElement.className = "fontBoldBlack";
break;
case "value":
vSrcElement.className = "fontBlack";
break;
default:
break;
}
}
